<?php
/* vim: set expandtab sw=4 ts=4 sts=4: */
/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog Forums Plugin 2.9.0                                               |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2011 by the following authors:                              |
// |    Geeklog Community Members   geeklog-forum AT googlegroups DOT com      |
// |                                                                           |
// | Copyright (C) 2000,2001 by the following authors:                         |
// |    Tony Bibbs       tony AT tonybibbs DOT com                             |
// |                                                                           |
// | Forum Plugin Authors                                                      |
// |    Mr.GxBlock                                        www.gxblock.com      |
// |    Matthew DeWyer   matt AT mycws DOT com            www.cweb.ws          |
// |    Blaine Lang      geeklog AT langfamily DOT ca     www.langfamily.ca    |
// +---------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// +---------------------------------------------------------------------------+

if (strpos(strtolower($_SERVER['PHP_SELF']), 'functions.inc') !== false) {
    die('This file can not be used on its own.');
}

// Need to declare this for global scope issues during install and upgrades
global $_DB_table_prefix, $LANG_configselects;

// used for Likes and Topic controls
define("PLUGIN_NAME_FORUM", 'forum');

// Forum topic type for Likes
define("LIKES_TYPE_FORUM_POST", 'post');

// Forum types for Geeklog Topic assignments
define("TOPIC_TYPE_FORUM_TOPIC", 'topic');
define("TOPIC_TYPE_FORUM_FORUM", 'forum');
define("TOPIC_TYPE_FORUM_CATEGORY", 'category');

/**
* Include language file
*/
$plugin_path = $_CONF['path'] . 'plugins/forum/';
$langfile = $plugin_path . 'language/' . $_CONF['language'] . '.php';
if (file_exists($langfile)) {
    require_once $langfile;
} else {
    require_once $plugin_path . 'language/english.php';
}
/**
 * This language string is inherited from Geeklog Core, which makes
 * it static, so we define it here instead of in the language files.
 */
global $LANG32, $_TABLES;

$PLG_forum_MESSAGE3002 = $LANG32[9]; // This plugin requires a newer version of Geeklog

/**
* Add to $_TABLES array the tables forum plugin uses
*/
$_TABLES['forum_userprefs']    = $_DB_table_prefix . 'forum_userprefs';
$_TABLES['forum_topic']        = $_DB_table_prefix . 'forum_topic';
$_TABLES['forum_categories']   = $_DB_table_prefix . 'forum_categories';
$_TABLES['forum_forums']       = $_DB_table_prefix . 'forum_forums';
$_TABLES['forum_watch']        = $_DB_table_prefix . 'forum_watch';
$_TABLES['forum_moderators']   = $_DB_table_prefix . 'forum_moderators';
$_TABLES['forum_banned_ip']    = $_DB_table_prefix . 'forum_banned_ip';
$_TABLES['forum_log']          = $_DB_table_prefix . 'forum_log';
$_TABLES['forum_userinfo']     = $_DB_table_prefix . 'forum_userinfo';

/**
 * DEPRECATED references to tables.
 * Do not use these, as they will be soon removed.
 *
 * TODO: remove these references in version 2.10.0
 */
$_TABLES['gf_userprefs']  = $_DB_table_prefix . 'forum_userprefs';
$_TABLES['gf_topic']      = $_DB_table_prefix . 'forum_topic';
$_TABLES['gf_categories'] = $_DB_table_prefix . 'forum_categories';
$_TABLES['gf_forums']     = $_DB_table_prefix . 'forum_forums';
$_TABLES['gf_watch']      = $_DB_table_prefix . 'forum_watch';
$_TABLES['gf_moderators'] = $_DB_table_prefix . 'forum_moderators';
$_TABLES['gf_banned_ip']  = $_DB_table_prefix . 'forum_banned_ip';
$_TABLES['gf_log']        = $_DB_table_prefix . 'forum_log';
$_TABLES['gf_userinfo']   = $_DB_table_prefix . 'forum_userinfo';

/**
* Load the plugin configuration
*/
$CONF_FORUM = array();
require_once $_CONF['path_system'] . 'classes/config.class.php';
$plg_config = config::get_instance();
$temp = $plg_config->get_config('forum');
if (is_array($temp)) {
    $CONF_FORUM = array_merge($CONF_FORUM, $temp);
    $CONF_FORUM['recaptcha'] = (isset($CONF_FORUM['recaptcha'])) ? (int) $CONF_FORUM['recaptcha'] : 0;
}

// *******************
// Hack to enable Site Notifications for new forum posts under Configuration -> Geeklog -> Miscellaneous -> Miscellaneous -> Notifications
// This really should be some sort of plugin api that could handle the notification in the Configuration if it has been added but the plugin is disabled or uninstalled
// Currently if plugin disabled and notification option exists then instead of saying 'New Forum Posts' it will default to first item in list
// Plus this is only in English
$LANG_configselects['Core'][25] = array_merge($LANG_configselects['Core'][25], array('New Forum Posts' => 'forum'));
// *******************

/**
* Include forum config file
*/
require_once $_CONF['path'] . 'plugins/forum/config.php';

$CONF_FORUM['debug'] = false;

$CONF_FORUM['layout_url']  = $_CONF['site_url'] . '/forum';
$CONF_FORUM['imgset']       = CTL_plugin_dirLocation('forum', 'image_set', true);
$CONF_FORUM['imgset_path']  = CTL_plugin_dirLocation('forum', 'image_set', false);
$CONF_FORUM['path_include'] = $_CONF['path'] . 'plugins/forum/include/';
$CONF_FORUM['charset']      = COM_getCharset();
$CONF_FORUM['add_forum_menu_check'] = 0; // Reset Check to false. If needed it is set to true in gf_format.php where then used by plugin_getBlocks_forum

// User Preference Config Parms. Check if user has set their preference or use defaults
if (!empty($_USER['uid']) AND ($_USER['uid'] > 1) AND DB_getItem($_TABLES['forum_userprefs'],"uid","uid='{$_USER['uid']}'") == $_USER['uid']) {
    $sql = DB_query("Select * FROM {$_TABLES['forum_userprefs']} WHERE uid = '{$_USER['uid']}'");
    $userprefs = DB_fetchArray($sql);
    $CONF_FORUM['show_topics_perpage']  = $userprefs['topicsperpage'];
    $CONF_FORUM['show_posts_perpage']   = $userprefs['postsperpage'];
    $CONF_FORUM['popular_limit']        = $userprefs['popularlimit'];
    $CONF_FORUM['show_members_perpage'] = $userprefs['membersperpage'];
    $CONF_FORUM['show_search_perpage']  = $userprefs['searchlines'];
    $CONF_FORUM['show_topicreview']     = $userprefs['showiframe'];
    $CONF_FORUM['show_anonymous_posts'] = $userprefs['viewanonposts'];
    $CONF_FORUM['notify_once']          = $userprefs['notify_once'];
}

// Now make sure config options are setup okay and meet requirements else set to defaults (not min values)
// If make changes here make sure reflected in checks on userprefs.php page as these below can be affected by user prefs
$CONF_FORUM['show_topics_perpage'] = (isset($CONF_FORUM['show_topics_perpage']) && $CONF_FORUM['show_topics_perpage'] > 9) 			? $CONF_FORUM['show_topics_perpage']	: 10; // This default is also stored in DB
$CONF_FORUM['show_posts_perpage'] = (isset($CONF_FORUM['show_posts_perpage']) && $CONF_FORUM['show_posts_perpage'] > 2) 			? $CONF_FORUM['show_posts_perpage']		: 10; // This default is also stored in DB
$CONF_FORUM['popular_limit'] = isset($CONF_FORUM['popular_limit'])		 															? $CONF_FORUM['popular_limit']			: 0;  // This default is in config file
$CONF_FORUM['show_members_perpage'] = (isset($CONF_FORUM['show_members_perpage']) && $CONF_FORUM['show_members_perpage'] > 9) 		? $CONF_FORUM['show_members_perpage']	: 20; // This default is in config file
$CONF_FORUM['show_search_perpage'] = (isset($CONF_FORUM['show_search_perpage']) && $CONF_FORUM['show_search_perpage'] > 9) 			? $CONF_FORUM['show_search_perpage']	: 20; // This default is also stored in DB
// These below do not have user specific preference and are site wide
$CONF_FORUM['show_messages_perpage'] = (isset($CONF_FORUM['show_messages_perpage']) && $CONF_FORUM['show_messages_perpage'] > 9) 	? $CONF_FORUM['show_messages_perpage']	: 20; // This default is also stored in DB
$CONF_FORUM['show_newposts_perpage'] = (isset($CONF_FORUM['show_newposts_perpage']) && $CONF_FORUM['show_newposts_perpage'] > 9) 	? $CONF_FORUM['show_newposts_perpage']	: 20; // This default is in config file
$CONF_FORUM['show_popular_perpage'] = (isset($CONF_FORUM['show_popular_perpage']) && $CONF_FORUM['show_popular_perpage'] > 9) 		? $CONF_FORUM['show_popular_perpage']	: 20; // This default is in config file

$CONF_FORUM['installed_version'] = floatval(DB_getItem($_TABLES['plugins'], 'pi_version', "pi_name = 'forum'"));

/**
* Initialise the handling of smilies
*/
require_once $CONF_FORUM['path_include'] . 'ForumSmilies.class.php';
$_SMILIES = new ForumSmilies();

/**
* Returns the items for this plugin that should appear on the main menu
*/
function plugin_getmenuitems_forum()
{
    global $CONF_FORUM,$_CONF,$LANG_GF00;

    //if ($CONF_FORUM['registration_required'] == 0 || SEC_hasRights('forum.user')) {
	if ($CONF_FORUM['registration_required'] == 0 || ($CONF_FORUM['registration_required'] && SEC_hasRights('forum.user'))) {
        $menuitems["{$LANG_GF00['pluginlabel']}"] = "{$_CONF['site_url']}/forum/index.php";
        return $menuitems;
    }
}


function plugin_autotags_forum($op,$content='',$autotag='') {
    global $_CONF, $LANG_GF00, $LANG_GF01;

    if ($op == 'tagname') {
        return 'forum';
    } elseif ($op == 'description') {
        return array('forum' => $LANG_GF00['autotag_desc_forum']);
    } elseif ($op == 'parse') {
        $id = COM_applyFilter($autotag['parm1']);
        if (!empty($id)) {
            $linktext = $LANG_GF01['HERE'];
            if (!empty($autotag['parm2'])) $linktext = $autotag['parm2'];
            $url = forum_buildForumPostURL($id);
            $filelink = COM_createLink($linktext, $url);
            $content = str_replace($autotag['tagstr'], $filelink, $content);
        }
        return $content;
    }
}


/**
* This will put an option for forum admin in the command and control block on moderation.php
*
*/
function plugin_cclabel_forum()
{
    global $_CONF;
    if (SEC_hasRights('forum.edit')) {
        return array('Forum',$_CONF['site_admin_url'] . "/plugins/forum/index.php",$_CONF['site_url'] . '/forum/images/forum.png');
    }
}

/**
* returns the administrative option for this plugin
*
*/
function plugin_getadminoption_forum()
{
    global $_TABLES, $_CONF, $LANG_GF00;

    if (SEC_hasRights('forum.edit')) {
        $numtopics = DB_getItem($_TABLES['forum_topic'],"COUNT(*)");
        return array($LANG_GF00['pluginlabel'], $_CONF['site_admin_url'] . '/plugins/forum/index.php', $numtopics);
    }
}

/**
* Returns the user menuitem option for this plugin
* Only one menu item can be returned.
*/
function plugin_getuseroption_forum()
{
    global $CONF_FORUM, $_CONF, $LANG_GF00;

    // if ($CONF_FORUM['registration_required'] == 0 || SEC_hasRights('forum.user')) {
	if ($CONF_FORUM['registration_required'] == 0 || ($CONF_FORUM['registration_required'] && SEC_hasRights('forum.user'))) {
        return array($LANG_GF00['useradminmenu'], $_CONF['site_url'] . '/forum/userprefs.php', 0);
    }
}


function plugin_user_create_forum ($uid)
{
    global $_TABLES;

    DB_query ("INSERT INTO {$_TABLES['forum_userinfo']} (uid) VALUES ('{$uid}')");
}

/**
* Called if admin deletes a user - Removes any moderator and Watch Records for user
*/
function plugin_user_delete_forum ($uid)
{
    global $_TABLES;

    DB_query("DELETE FROM {$_TABLES['forum_moderators']} WHERE mod_uid ='$uid'");
    DB_query("DELETE FROM {$_TABLES['forum_watch']} WHERE uid ='$uid'");
    DB_query("DELETE FROM {$_TABLES['forum_userinfo']} WHERE uid ='$uid'");
    DB_query("DELETE FROM {$_TABLES['forum_userprefs']} WHERE uid ='$uid'");
    DB_query("DELETE FROM {$_TABLES['forum_log']} WHERE uid ='$uid'");
    DB_query("UPDATE {$_TABLES['forum_topic']} SET uid = 1 WHERE uid = '$uid'");
}

function plugin_profileextrassave_forum($uid = '')
{
    global $_CONF,$_USER, $HTTP_POST_VARS, $_TABLES, $CONF_FORUM;

    require_once $CONF_FORUM['path_include'] . 'gf_format.php';

    if (empty($uid)) {
        $uid = $_USER['uid'];
    }

    // Make sure post variables are set. Remember edit can happen by User for User Settings and edit/new by Admin on User Admin form
    // Forum plugin fields display both on the Admin User form and the user settings form (so no reason to check which form we are on)
    if ($uid > 1) {
        $aim        = isset($_POST['forum_aim'])        ? gf_preparefordb($_POST['forum_aim'],'html')  : '';
        $icq        = isset($_POST['forum_icq'])        ? gf_preparefordb($_POST['forum_icq'],'html')  : '';
        $yim        = isset($_POST['forum_yim'])        ? gf_preparefordb($_POST['forum_yim'],'html')  : '';
        $msnm       = isset($_POST['forum_msnm'])       ? gf_preparefordb($_POST['forum_msnm'],'html')  : '';
        $interests  = isset($_POST['forum_interests'])  ? gf_preparefordb($_POST['forum_interests'],'html')  : '';
        $occupation = isset($_POST['forum_occupation']) ? gf_preparefordb($_POST['forum_occupation'],'html')  : '';
        DB_save ($_TABLES['forum_userinfo'], "uid,aim,yim,icq,msnm,interests,occupation",
                 "'$uid','$aim','$yim','$icq','$msnm','$interests','$occupation'");
   }
}


function plugin_profilevariablesedit_forum($uid, &$template)
{
    global $_TABLES, $LANG_GF04, $CONF_FORUM;

    // Remember edit can happen by User for User Settings and edit/new by Admin on User Admin form
    // Forum plugin fields display both on the Admin User form and the user settings form
    if ($uid > 1) {
        $result = DB_query ("SELECT uid,aim,icq,yim,msnm,interests,occupation FROM {$_TABLES['forum_userinfo']} WHERE uid = $uid");
        $A = DB_fetchArray ($result);
    } else {
        $A['aim'] = '';
        $A['icq'] = '';
        $A['yim'] = '';
        $A['msnm'] = '';
        $A['interests'] = '';
        $A['occupation'] = '';
    }

    if ($CONF_FORUM['profile']['aim']) {
        $template->set_var ('lang_field', $LANG_GF04['label_aim']);
        $template->set_var ('lang_field_text', '');
        $template->set_var('field', $A['aim']);
        $template->set_var('fieldname', 'forum_aim');
        $template->set_var('fieldmaxlength', '128');
        $template->parse('display_fields', 'display_field', true);
    }

    if ($CONF_FORUM['profile']['icq']) {
        $template->set_var ('lang_field', $LANG_GF04['label_icq']);
        $template->set_var ('lang_field_text', '');
        $template->set_var('field', $A['icq']);
        $template->set_var('fieldname', 'forum_icq');
        $template->set_var('fieldmaxlength', '128');
        $template->parse('display_fields', 'display_field', true);
    }

    if ($CONF_FORUM['profile']['yim']) {
        $template->set_var ('lang_field', $LANG_GF04['label_yim']);
        $template->set_var ('lang_field_text', '');
        $template->set_var('field', $A['yim']);
        $template->set_var('fieldname', 'forum_yim');
        $template->set_var('fieldmaxlength', '128');
        $template->parse('display_fields', 'display_field', true);
    }

    if ($CONF_FORUM['profile']['msnm']) {
        $template->set_var ('lang_field', $LANG_GF04['label_msnm']);
        $template->set_var ('lang_field_text', '');
        $template->set_var('field', $A['msnm']);
        $template->set_var('fieldname', 'forum_msnm');
        $template->set_var('fieldmaxlength', '128');
        $template->parse('display_fields', 'display_field', true);
    }

    if ($CONF_FORUM['profile']['interests']) {
        $template->set_var ('lang_field', $LANG_GF04['label_interests']);
        $template->set_var ('lang_field_text', '');
        $template->set_var('field', $A['interests']);
        $template->set_var('fieldname', 'forum_interests');
        $template->set_var('fieldmaxlength', '255');
        $template->parse('display_fields', 'display_field', true);
    }

    if ($CONF_FORUM['profile']['occupation']) {
        $template->set_var ('lang_field', $LANG_GF04['label_occupation']);
        $template->set_var ('lang_field_text', '');
        $template->set_var('field', $A['occupation']);
        $template->set_var('fieldname', 'forum_occupation');
        $template->set_var('fieldmaxlength', '255');
        $template->parse('display_fields', 'display_field', true);
    }
}

function plugin_profilevariablesdisplay_forum ($uid, &$template)
{
    global $_TABLES, $_CONF, $LANG_GF02, $LANG_GF04, $CONF_FORUM;

    $postlimit = "10";        // How many posts you want displayed

    $username = DB_getItem ($_TABLES['users'], 'username', "uid = $uid");
    $title = sprintf($LANG_GF02['msg158'], $postlimit, $username);
    $template->set_var ('start_block_last10', COM_startBlock($title));
    $template->set_var('end_block', COM_endBlock());

    $query = DB_query ("SELECT id,date,forum,subject FROM {$_TABLES['forum_topic']} WHERE uid = {$uid} ORDER BY date DESC LIMIT 100");
    $numposts = 0;

    while (list($postid,$date,$forum_id,$subject) = DB_fetchArray($query))  {
        $grp_id = DB_getItem($_TABLES['forum_forums'],'grp_id',"forum_id='$forum_id'");
        $groupname = DB_getItem($_TABLES['groups'],'grp_name',"grp_id='$grp_id'");
        if (SEC_inGroup($groupname) OR $grp_id == 2) {
            $numposts++;
            $postdate = COM_getUserDateTimeFormat ($date);
            $template->set_var ('row_number', $numposts . '.');
			$articleUrl = forum_buildForumPostURL($postid);
            $template->set_var('item_title',
                COM_createLink(
                    stripslashes($subject),
                    $articleUrl,
                    array('class'=>'b'))
            );
            $template->set_var ('item_date', $postdate[0]);

            if ($numposts == 1) {
                $template->parse('last10_rows', 'last10_row');
            } else {
                $template->parse('last10_rows', 'last10_row', true);
            }

            if ($numposts >= $postlimit) {
                break;
            }
        }
    }

    if ($numposts == 0) {
        $template->set_var('last10_rows', $LANG_GF02['msg155']);
    }
    $template->parse('last10_blocks', 'last10_block', true);

    // Cannot take just this as may include posts the user viewing does not have access too see new solution below
    //$count = DB_count ($_TABLES['forum_topic'], 'uid', $uid);

    // Taken in part from COM_getPermSQL
    // Cannot use COM_getPermSQL as it includes other security table columns like owner_id which the forum does not use
    // Grab current user group access as they can only know of forum posts they have access to about the user they are viewing
    $UserGroups = SEC_getUserGroups();
    $sql = "SELECT COUNT(uid) count_uid FROM {$_TABLES['forum_topic']} ft, {$_TABLES['forum_forums']} ff, {$_TABLES['groups']} g
            WHERE ft.forum = ff.forum_id AND ff.grp_id = g.grp_id
            AND ft.uid = {$uid} ";
    $sql .= "AND (g.grp_id = 2 OR (ff.grp_id IN (" . implode(',', $UserGroups) . ")))";
    $result = DB_query($sql);
    $A = DB_fetchArray($result);
    $count = $A['count_uid'];

    $template->set_var ('lang_number_field', $LANG_GF02['msg156']);
    $template->set_var ('number_field', COM_numberFormat($count));
    $template->parse('field_statistics', 'field_statistic', true);

    /* Display Instant Messaging Handles */
    $result = DB_query ("SELECT uid,aim,icq,yim,msnm,interests,occupation FROM {$_TABLES['forum_userinfo']} WHERE uid = $uid");
    $A = DB_fetchArray ($result);

    if ($CONF_FORUM['profile']['aim']) {
        $template->set_var ('lang_field', $LANG_GF04['label_aim']);
        $template->set_var('field', $A['aim']);
        $template->parse('display_fields', 'display_field', true);
    }

    if ($CONF_FORUM['profile']['icq']) {
        $template->set_var ('lang_field', $LANG_GF04['label_icq']);
        $template->set_var('field', $A['icq']);
        $template->parse('display_fields', 'display_field', true);
    }

    if ($CONF_FORUM['profile']['yim']) {
        $template->set_var ('lang_field', $LANG_GF04['label_yim']);
        $template->set_var('field', $A['yim']);
        $template->parse('display_fields', 'display_field', true);
    }

    if ($CONF_FORUM['profile']['msnm']) {
        $template->set_var ('lang_field', $LANG_GF04['label_msnm']);
        $template->set_var('field', $A['msnm']);
        $template->parse('display_fields', 'display_field', true);
    }

    if ($CONF_FORUM['profile']['interests']) {
        $template->set_var ('lang_field', $LANG_GF04['label_interests']);
        $template->set_var('field', $A['interests']);
        $template->parse('display_fields', 'display_field', true);
    }

    if ($CONF_FORUM['profile']['occupation']) {
        $template->set_var ('lang_field', $LANG_GF04['label_occupation']);
        $template->set_var('field', $A['occupation']);
        $template->parse('display_fields', 'display_field', true);
    }
}

function plugin_statssummary_forum() {
    global $_CONF, $_TABLES, $LANG_GF00;

    // This shows in the summary box
    $total_items = DB_count($_TABLES['forum_topic']);      // Total number of Forum Posts
    $summary_label = $LANG_GF00['statslabel'];
    $retval[] = $summary_label;
    $retval[] = $total_items;
    return $retval;
}

/**
* shows the statistics for the plugin when stats.php is called.
* If $showsitestats is 1 then we are to only print the overall stats in the 'site statistics box'
* otherwise we show the detailed stats for the photo album
*
* @showsitestate        int         Flag to let us know which stats to get
*/
function plugin_showstats_forum($showsitestats)
{
    global $_CONF, $_TABLES, $LANG_GF00,$LANG_GF01, $CONF_FORUM;

    // Use themes stats template files
    if (COM_versionCompare(VERSION, '2.2.0', '>=')) {
        $stat_templates = COM_newTemplate(CTL_core_templatePath($_CONF['path_layout'] . 'stats'));
    } else { // For Geeklog 2.1.3 support
        $stat_templates = COM_newTemplate($_CONF['path_layout'] . '/stats');
    }
    $stat_templates->set_file(array('itemstats'=>'itemstatistics.thtml',
                            'statrow'=>'singlestat.thtml'));

    $retval = '';

    $header_arr = array(
        array('text' => $LANG_GF01['TOPICSUBJECT'], 'field' => 'topicsubject'),
        array('text' => $LANG_GF01['VIEWS'], 'field' => 'views'),
    );
    $data_arr = array();
    $text_arr = array('has_menu'     => false,
                      'title'        => $LANG_GF00['statsheading1'],
    );
    $result = DB_query("SELECT forum,subject,views,id FROM {$_TABLES['forum_topic']} WHERE pid='0' ORDER BY views DESC");
    $nrows  = DB_numRows($result);
    if ($nrows > 0) {
        $displaycount = 0;
        while (list ($forum,$subject, $views,$id) = DB_fetchARRAY($result)) {
            $forum_id = DB_getItem($_TABLES['forum_topic'],'forum',"id='$id'");
            $grp_id = DB_getItem($_TABLES['forum_forums'],'grp_id',"forum_id='$forum_id'");
            $groupname = DB_getItem($_TABLES['groups'],'grp_name',"grp_id='$grp_id'");
            if (SEC_inGroup($groupname) OR $grp_id == 2) {
				$url = forum_buildForumPostURL($id);
                $S['topicsubject'] = '<a href="' . $url . '">' . $subject . '</a>';
                $S['views']  = COM_numberFormat($views);
                $data_arr[$displaycount] = $S;
                $displaycount++;
                if ($displaycount > 10) {
                    break;
                }
            }
        }
        $retval .= ADMIN_simpleList("", $header_arr, $text_arr, $data_arr);
    } else {
        $retval .= $LANG_GF00['statsheading3'];
    }
    $header_arr = array(
        array('text' => $LANG_GF01['TOPICSUBJECT'], 'field' => 'topicsubject'),
        array('text' => $LANG_GF01['REPLIES'], 'field' => 'replies'),
    );
    $data_arr = array();
    $text_arr = array('has_menu'     => false,
                      'title'        => $LANG_GF00['statsheading2'],
    );
    $result = DB_query("SELECT forum,subject,replies,id FROM {$_TABLES['forum_topic']} WHERE pid='0' ORDER BY replies DESC");
    $nrows  = DB_numRows($result);
    if ($nrows > 0) {
        $stat_templates->set_var('item_label',$LANG_GF01['TOPICSUBJECT']);
        $stat_templates->set_var('stat_name',$LANG_GF01['REPLIES']);
        $displaycount=0;
        while (list ($forum,$subject, $replies,$id) = DB_fetchARRAY($result)) {
            $forum_id = DB_getItem($_TABLES['forum_topic'],'forum',"id='$id'");
            $grp_id = DB_getItem($_TABLES['forum_forums'],'grp_id',"forum_id='$forum_id'");
            $groupname = DB_getItem($_TABLES['groups'],'grp_name',"grp_id='$grp_id'");
            if (SEC_inGroup($groupname) OR $grp_id == 2) {
                $url = forum_buildForumPostURL($id);
                $S['topicsubject'] = '<a href="' . $url . '">' . $subject . '</a>';
                $S['replies']  = COM_numberFormat($replies);
                $data_arr[$displaycount] = $S;
                $displaycount++;
                if ($displaycount > 10) {
                    break;
                }
            }
        }
        $retval .= ADMIN_simpleList("", $header_arr, $text_arr, $data_arr);
    } else {
        $retval .= $LANG_GF00['statsheading3'];
    }

    return $retval;
}


/**
* Geeklog is asking us to provide any new items that show up in the type drop-down
* on search.php.  Let's let users search the Filelistings in the Filemgmt Plugin
*
*/
function plugin_searchtypes_forum()
{
    global $LANG_GF00;

    $tmp['forum'] = $LANG_GF00['searchlabel'];
    return $tmp;
}


/**
* this searches for files matching the user query and returns an array of
* for the header and table rows back to search.php where it will be formated and
* printed
*
* @param    string  $query      Keywords user is looking for
* @param    date    $datestart  Start date to get results for
* @param    date    $dateend    End date to get results for
* @param    string  $topic      The topic they were searching in
* @param    string  $type       Type of items they are searching, or 'all' (deprecated)
* @param    int     $author     Get all results by this author
* @param    string  $keyType    search key type: 'all', 'phrase', 'any'
* @param    int     $page       page number of current search (deprecated)
* @param    int     $perpage    number of results per page (deprecated)
* @return   object              search result object
*
*/
function plugin_dopluginsearch_forum($query, $datestart, $dateend, $topic, $type, $author, $keyType, $page, $perpage)
{
    global $LANG_GF01, $_TABLES, $_GROUPS;

    // Make sure the query is SQL safe
    $query = trim(addslashes($query));

	if (COM_versionCompare(VERSION, '2.2.1sr1', '>=')) {
		$sql = "SELECT ft.id, ft.date, ft.subject AS title, ft.comment AS description, ft.views AS hits, ft.uid, "
			 . "'' AS url " // empty URL means will be defined later based on id
			 . "FROM {$_TABLES['forum_topic']} ft, {$_TABLES['forum_forums']} ff "
			 . "WHERE ft.forum = ff.forum_id AND (ff.grp_id IN ('" . implode( "','", $_GROUPS ) . "')) AND ft.date <> 1 ";
	} else {
		// https://github.com/Geeklog-Plugins/forum/issues/87
		// As of Forum v2.9.4 forum topic URL now required to use parent topic and page number. In search sql URL can now be changed before display (as of Geeklog v2.2.1sr1)
		$sql = "SELECT ft.id, ft.date, ft.subject AS title, ft.comment AS description, ft.views AS hits, ft.uid, "
			 . "CONCAT('/forum/viewtopic.php?showtopic=', ft.id) AS url "
			 . "FROM {$_TABLES['forum_topic']} ft, {$_TABLES['forum_forums']} ff "
			 . "WHERE ft.forum = ff.forum_id AND (ff.grp_id IN ('" . implode( "','", $_GROUPS ) . "')) AND ft.date <> 1 ";
	}

	if (!empty($datestart) || !empty($dateend)) {
		// Do some date checking and fill in missing dates
		$delim = '-';
		if (empty($datestart) || (strtotime($datestart) == false)) {
			$datestart = "0000-00-00";
		} else {
			$datestart = date('Y-m-d', strtotime($datestart));
		}
		if (empty($dateend) || (strtotime($dateend) == false)) {
			$dateend = date('Y-m-d');
		} else {
			$dateend = date('Y-m-d', strtotime($dateend));
		}

		$DS = explode($delim, $datestart);
		$DE = explode($delim, $dateend);
		$startdate = mktime(0,0,0,$DS[1],$DS[2],$DS[0]);
		$enddate = mktime(23,59,59,$DE[1],$DE[2],$DE[0]);

		//return " $type (UNIX_TIMESTAMP($column) BETWEEN '$startdate' AND '$enddate') ";
		$sql .= "AND (date BETWEEN '$startdate' AND '$enddate') ";
	}

    if (!empty($author)) {
        $sql .= "AND (uid = '$author') ";
    }

    $search = new SearchCriteria('forum', $LANG_GF01['FORUM']);
    $columns = array('title' => 'subject', 'comment');
    list($sql,$ftsql) = $search->buildSearchSQL($keyType, $query, $columns, $sql);
    $search->setSQL($sql);
    $search->setFTSQL($ftsql);
    $search->setRank(3);
    $search->setAppendQuery(true);

    return $search;
}

// Format content to be displayed in the search results
function plugin_searchformat_forum($id, $contentType, $content)
{
	// Remove any BBCode from forum post
	if ($contentType == 'description') {
		return forum_stripBBCode($content);
	} elseif ($contentType == 'url') {
		// For URL content contain query info
		return html_entity_decode(forum_buildForumPostURL($id));  // For some reason urldecode was not converting the &amp; in the query string so used html_entity_decode
	}
}

/* RSS FEED Related API functions */

function plugin_getfeednames_forum ()
{
    global $_TABLES;

    $feeds = array ();
    $result = DB_query ("SELECT forum_id,forum_name FROM {$_TABLES['forum_forums']} ORDER BY forum_order");
    $num = DB_numRows ($result);

    if ($num > 0) {
        $feeds[] = array ('id' => '0', 'name' => 'all forums');
    }

    for ($i = 0; $i < $num; $i++) {
        $A = DB_fetchArray ($result);
        $feeds[] = array ('id' => $A['forum_id'], 'name' => $A['forum_name']);
    }

    return $feeds;
}

function forum_buildFeedsSql ($forumID, $limits)
{
    global $CONF_FORUM;

    if ($CONF_FORUM['installed_version'] < 2.6) {
        return '';
    }

    $groups = array ();
    $usergroups = SEC_getUserGroups(1);
    foreach ($usergroups as $group) {
        $groups[] = $group;
    }
    $grouplist = implode(',',$groups);

    if ($forumID > 0) {
        $where = " WHERE forum=$forumID AND no_newposts=0 AND forum.grp_id IN ($grouplist) ";
    } else {
        $where = " WHERE no_newposts=0 AND forum.grp_id IN ($grouplist) ";
    }
    $limitsql = '';
    if (!empty ($limits)) {
        if (substr ($limits, -1) == 'h') { // last xx hours
            $limitsql = '';
            $hours = substr ($limits, 0, -1);
            if (!empty ($where)) {
                $where .= ' AND ';
            }
            $where .= "date >= DATE_SUB(NOW(),INTERVAL $hours HOUR) ORDER BY date DESC";
        } else {
            $limitsql = ' ORDER BY date DESC LIMIT ' . $limits;
        }
    }
    else
    {
        $limitsql = ' ORDER BY date DESC LIMIT 10';
    }

    $sql = $where . $limitsql;

    return $sql;
}

function plugin_getfeedcontent_forum ($feed, &$link, &$update)
{
    global $_CONF, $_TABLES, $CONF_FORUM, $LANG_GF01;

    $content = array();
    $lids = array();
    $ids = array();

    if ($CONF_FORUM['installed_version'] < 2.6) {
        return $content;
    }

    $allow_smilies = $CONF_FORUM['allow_smilies'];
    $CONF_FORUM['allow_smilies']=0;

    require_once $CONF_FORUM['path_include'] . 'gf_format.php';
    if ( !function_exists('str_ireplace'))
    {
        require_once 'PHP/Compat.php';
        PHP_Compat::loadFunction( 'str_ireplace' );
    }
    require_once $CONF_FORUM['path_include'] . 'bbcode/stringparser_bbcode.class.php';

    $result = DB_query ("SELECT topic,limits,content_length FROM {$_TABLES['syndication']} WHERE fid = $feed");
    $F = DB_fetchArray ($result);

    $sql = "SELECT topic.id,topic.forum,topic.subject,topic.uid,topic.name,topic.comment,topic.date,topic.postmode,forum.forum_name,forum.grp_id ";
    $sql .= "FROM {$_TABLES['forum_topic']} topic LEFT JOIN {$_TABLES['forum_forums']} forum ON topic.forum=forum.forum_id ";
    $sql .= forum_buildFeedsSql ($F['topic'], $F['limits']);
    $result = DB_query ($sql);

    while ($A = DB_fetchArray($result)) {
        $preface = '';
        if ($F['content_length'] == 0) {
            $comment = '';
        } elseif ($F['content_length'] > 1) {
            if ($A['postmode'] == 'html' || $A['postmode'] == 'HTML') {
                $comment = COM_truncateHTML($A['comment'], $F['content_length'], '...');
            } else {
                $comment = COM_truncate($A['comment'], $F['content_length'], '...');
            }
        } else {
            $comment = $A['comment'];
            $preface = $LANG_GF01['BY'] . ' ';
            if ( $A['uid'] > 1 ) {
                $preface .= '<a href="' . $_CONF['site_url'] . '/users.php?mode=profile&amp;uid=' . $A['uid'] . '">' . $A['name'] . '</a>';
            } else {
                $preface .= $A['name'];
            }
            $preface .= '<br' . XHTML . '><br' . XHTML . '>';
        }
        // Handle Pre ver 2.5 quoting and New Line Formatting - consider adding this to a migrate function
        if ($CONF_FORUM['pre2.5_mode']) {
            if ( stristr($comment,'[code') == false ) {
                $comment = str_replace('<pre>','[code]',$comment);
                $comment = str_replace('</pre>','[/code]',$comment);
            }
            $comment = str_replace(array("<br" . XHTML . ">\r\n","<br" . XHTML . ">\n\r","<br" . XHTML . ">\r","<br" . XHTML . ">\n"), '<br' . XHTML . '>', $comment );
            $comment = preg_replace("/\[QUOTE\sBY=\s(.+?)\]/i","[QUOTE] Quote by $1:",$comment);
            /* Reformat code blocks - version 2.3.3 and prior */
            $comment = str_replace( '<pre class="forumCode">', '[code]', $comment );
            $comment = preg_replace("/\[QUOTE\sBY=(.+?)\]/i","[QUOTE] Quote by $1:",$comment);
        }

        $comment = gf_formatTextBlock($comment,$A['postmode'],'preview');

        $comment = str_replace('{','&#123;',$comment);
        $comment = str_replace('}','&#125;',$comment);

        // we don't have a stylesheet in the news feed, so replace our div with the style...
        $comment = str_replace('<div class="quotemain">','<div style="border: 1px dotted #000;border-left: 4px solid #8394B2;color:#465584;  padding: 4px;  margin: 5px auto 8px auto;">',$comment);

        $desc = $preface . $comment;

		$link = forum_buildForumPostURL($A['id']);

        $content[] = array ('title'     => $A['forum_name'] . ' :: ' . $A['subject'],
                            'summary'   => $desc,
                            'text'      => $desc,
                            'link'      => $link,
                            'uid'       => $A['uid'],
                            'date'      => $A['date'],
                            'format'    => $A['postmode'],
                           );
        $ids[] = $A['id'];
    }

    if ($F['topic'] == 0) {
        $link = "{$_CONF['site_url']}/forum/index.php";
    } else {
        $link = "{$_CONF['site_url']}/forum/index.php.php?forum={$F['topic']}";
    }

    if (count($ids) > 0 ) {
        $update = implode (',', $ids);
    }

    $CONF_FORUM['allow_smilies'] = $allow_smilies;

    return $content;
}

function plugin_feedupdatecheck_forum ($feed, $topic, $update_data, $limit)
{
    global $_TABLES;

    $sql = "SELECT id,forum.grp_id FROM {$_TABLES['forum_topic']} topic LEFT JOIN {$_TABLES['forum_forums']} forum ON topic.forum=forum.forum_id " . forum_buildFeedsSql ($topic, $limit);
    $result = DB_query ($sql);
    $num = DB_numRows ($result);

    $ids = array ();
    for ($i = 0; $i < $num; $i++) {
        $A = DB_fetchArray ($result);
        $ids[] = $A['id'];
    }
    $current = implode (',', $ids);

    //COM_errorLog ("Update check for downloads: comparing new list ($current) with old list ($update_data)", 1);

    return ( $current != $update_data ) ? false : true;
}

/* End of RSS Feed Related Functions */



/**
* Called by the plugin Editor to display the current plugin code version
* This may be different then the version installed and registered currently.
* If newer then you may want to run the update
*/
function plugin_chkVersion_forum() {
    global $_CONF;
    static $pi_version = NULL;

    if ($pi_version === NULL) {
        require_once $_CONF['path'] . 'plugins/forum/autoinstall.php';
        $inst_parms = plugin_autoinstall_forum('forum');
        $pi_version = $inst_parms['info']['pi_version'];
    }
    return $pi_version;
}


/**
* Called by the plugin Editor to run the SQL Update for a plugin update
*/
function plugin_upgrade_forum() {
    global $_CONF, $_TABLES, $CONF_FORUM;

    $installed_version = DB_getItem($_TABLES['plugins'], 'pi_version', "pi_name = 'forum'");
    $code_version = plugin_chkVersion_forum();
    if ($installed_version == $code_version) return true; // nothing to do

    require_once $_CONF['path'] . 'plugins/forum/autoinstall.php';
    if (!plugin_compatible_with_this_version_forum('forum')) return 3002;

    // Retrieve other plugin info like min geeklog version and homepage
    $inst_parms = plugin_autoinstall_forum('forum');

    $current_version = $installed_version;

    // Include the upgrade functions
    require_once $_CONF['path'] . 'plugins/forum/upgrade.inc';

    $done = false;
    while (!$done) {
        switch ($current_version) {
            case "2.3" :
            case "2.3.2" :
                if (upgrade_232() != 0) break 2;

                $current_version = "2.5RC1";

                break;

            case "2.5RC1" :
                if (upgrade_25() != 0) break 2;

                $current_version = "2.6";

                break;

            case "2.6" :
            case "2.7" :
            case "2.7.1" :
            case "2.7.2" :
            case "2.7.2.JPr5" :
            case "2.7.2.JPr6" :
            case "2.7.3" :
            case "2.7.3.JPr1" :
            case "2.7.4" :
            case "2.7.4.JPr1" :
            case "2.7.5.JPr1" :
                if (upgrade_274() != 0) break 2;

                $current_version = "2.8.0";

                break;

            case "2.8.0" :
                if (upgrade_280() != 0) break 2;

                $current_version = "2.9.0";

                break;

            case "2.9.0" :
                if (upgrade_290() != 0) break 2;

                $current_version = "2.9.1";

                break;

            case "2.9.1" :

                $current_version = "2.9.2";

                break;

            case "2.9.2" :
                if (upgrade_293() != 0) break 2;

                $current_version = "2.9.3";

                break;

            case "2.9.3" :
				if (upgrade_294() != 0) break 2;

                $current_version = "2.9.4";

                break;

            default:
                $done = true;
                break;
        }
    }

    // update plugin version number and other info
    DB_query("UPDATE {$_TABLES['plugins']} SET pi_version = '$code_version', pi_gl_version = '{$inst_parms['info']['pi_gl_version']}', pi_homepage = '{$inst_parms['info']['pi_homepage']}' WHERE pi_name = 'forum'");

    COM_errorLog( "Updated forum plugin from v$installed_version to v$code_version", 1 );

    // Check if update completed and return a message number to be shown
    if (DB_getItem($_TABLES['plugins'],'pi_version',"pi_name = 'forum'") == $code_version) {
        return 1;
    } else {
        return 5;
    }
}

/**
* Called during site migration - handle changed URLs or paths
*
* @param    array   $old_conf   contents of the $_CONF array on the old site
* @param    boolean             true on success, otherwise false
*
*/
function plugin_migrate_forum($old_conf)
{
    global $_CONF;

    $tables = array(
        'forum_topic'      => 'id, comment',
        'forum_categories' => 'id, cat_dscp',
        'forum_forums'     => 'forum_id, forum_dscp'
    );

    if ($old_conf['site_url'] != $_CONF['site_url']) {
        Installer::updateSiteUrl($old_conf['site_url'], $_CONF['site_url'], $tables);
    }

    COM_errorLog('Successfully migrated the "forum" plugin');

    return true;
}

/**
* Automatic uninstall function for plugins
*
* @return   array
*
* This code is automatically uninstalling the plugin.
* It passes an array to the core code function that removes
* tables, groups, features and php blocks from the tables.
* Additionally, this code can perform special actions that cannot be
* foreseen by the core code (interactions with other plugins for example)
*
*/
function plugin_autouninstall_forum()
{
    $out = array (
        /* give the name of the tables, without $_TABLES[] */
        'tables' => array('forum_topic','forum_categories','forum_forums',
                          'forum_watch','forum_moderators','forum_banned_ip',
                          'forum_log', 'forum_userprefs','forum_userinfo'),
        /* give the full name of the group, as in the db */
        'groups' => array('forum Admin'),
        /* give the full name of the feature, as in the db */
        'features' => array('forum.edit', 'forum.user'),
        /* give the full name of the block, including 'phpblock_', etc */
        'php_blocks' => array('phpblock_forum_newposts', 'phpblock_forum_menu'), // Keep this in for old installs
        /* give all vars with their name */
        'vars'=> array()
    );
    return $out;
}

/**
 * This function is called when a user's information
 * (profile or preferences) has changed.
 *
 * @param    int $uid user id
 * @return   void
 */
function plugin_user_changed_forum($uid)
{
    global $_TABLES, $CONF_FORUM;

	if ($uid > 1) { // For only regular users
		// moderators use just username
		DB_query("UPDATE {$_TABLES['forum_moderators']} SET mod_username = (SELECT username FROM {$_TABLES['users']} WHERE uid = mod_uid) WHERE mod_uid = $uid");

		// with topics, display name is used
		require_once $CONF_FORUM['path_include'] . 'gf_format.php';
		$username = gf_preparefordb(COM_getDisplayName($uid), 'text');
		DB_query("UPDATE {$_TABLES['forum_topic']} ft SET ft.name = '$username' WHERE uid = $uid");
	}
}


function plugin_collectSitemapItems_forum($uid, $limit)
{
	global $_CONF, $_TABLES, $_GROUPS, $CONF_FORUM;

	// Let's only add
	// - Forum Index Link (as that lists all Category and Forum URLs)
	// - Forum Topics

	$retval = [];

	if ($CONF_FORUM['registration_required'] == 0 || ($CONF_FORUM['registration_required'] && SEC_hasRights('forum.user', 'AND', $uid))) {
		// Add Forum Index
		$retval[] = ['url' => $_CONF['site_url'] . '/forum/index.php'];

		$what = 'url,date-modified';
		$properties = explode(',', $what);

		// Figure out permissions and only list topic post (pid = 0)
		// 0 = current user
		if ($uid > 0) {
			$userGroups = SEC_getUserGroups($uid);

		} else {
			$userGroups = $_GROUPS;
		}
		$where = " AND (ff.grp_id IN (" . implode(",", $userGroups) . "))";
		$sql = "SELECT ft.id, ft.date,"
				. " (SELECT ft2.date FROM {$_TABLES['forum_topic']} ft2 WHERE ft.id = ft2.pid ORDER BY ft2.date DESC LIMIT 1) replydate" // find date of topic and latest date of any replies. Use newest one as modify date
				. " FROM {$_TABLES['forum_topic']} ft, {$_TABLES['forum_forums']} ff"
				. " WHERE pid = 0 AND ft.forum = ff.forum_id $where";

		if ($limit > 0) {
			$sql .= " LIMIT $limit";
		}
		$result = DB_query($sql);
		$numRows = DB_numRows($result);

		for ($i = 0; $i < $numRows; $i++) {
			$A = DB_fetchArray($result);

			$props = [];
			foreach ($properties as $p) {
				switch ($p) {
				case 'date-modified':
					// Use newest date (the only way the topic date could be newer is if it was edited last)
					if ($A['date'] > $A['replydate']) {
						$props['date-modified'] = $A['date'];
					} else {
						$props['date-modified'] = $A['replydate'];
					}
					break;
				case 'url':
					$props['url'] = html_entity_decode(forum_buildForumPostURL($A['id']));
					break;
				}
			}

			$retval[] = $props;
		}
	}

    return $retval;

}

/**
* Return information for a forum topic
*
* @param    string  $id         link ID or '*'
* @param    string  $what       comma-separated list of properties
* @param    int     $uid        user ID or 0 = current user
* @param    array   $options    (reserved for future extensions)
* @return   mixed               string or array of strings with the information
*
*/
function plugin_getiteminfo_forum($id, $what, $uid = 0, $options = array())
{
    global $_CONF, $_TABLES, $_GROUPS, $CONF_FORUM;


	$retval = [];

    // parse $what to see what we need to pull from the database
    $properties = explode(',', $what);
    $fields = array();
    foreach ($properties as $p) {
        switch ($p) {
        case 'date-modified':
            $fields[] = 'ft.date';
            break;
        case 'description':
        case 'excerpt':
            $fields[] = 'ft.comment';
            break;
        case 'id':
            $fields[] = 'ft.id';
            break;
        case 'title':
            $fields[] = 'ft.subject';
            break;
        case 'url':
            // needed for $id == '*', but also in case we're only requesting
            // the URL (so that $fields isn't empty)
            $fields[] = 'ft.id';
            break;
        default:
            // nothing to do
            break;
        }
    }

    $fields = array_unique($fields);

	// Check if any fields found we can return
    if (count($fields) == 0) {
        return $retval;
    }

	// Check is anonymous users can access and if not, regular user can access
	if ($CONF_FORUM['registration_required'] && !SEC_hasRights('forum.user', 'AND', $uid)) {
        return $retval;
    }

    // prepare SQL request
    if ($id == '*') {
        $where = '';
    } else {
        $where = " AND ft.id = $id";
    }

	// Figure out permissions
	if ($uid > 0) {
		$userGroups = SEC_getUserGroups($uid);

	} else {
		$userGroups = $_GROUPS;
	}
	$where .= " AND (ff.grp_id IN (" . implode(",", $userGroups) . "))";

    $sql = "SELECT " . implode(',', $fields)
            . " FROM {$_TABLES['forum_topic']} ft, {$_TABLES['forum_forums']} ff"
			. " WHERE ft.forum = ff.forum_id $where";

    if ($id != '*') {
        $sql .= ' LIMIT 1';
    }

    $result = DB_query($sql);
    $numRows = DB_numRows($result);

    for ($i = 0; $i < $numRows; $i++) {
        $A = DB_fetchArray($result);

        $props = array();
        foreach ($properties as $p) {
            switch ($p) {
            case 'date-modified':
                $props['date-modified'] = $A['date'];
                break;
            case 'description':
            case 'excerpt':
                $props[$p] = stripslashes($A['comment']);
                break;
            case 'id':
                $props['id'] = $A['id'];
                break;
            case 'title':
                $props['title'] = stripslashes($A['subject']);
                break;
            case 'url':
				// Decode as could be used in redirect etc...
                if (empty($A['id'])) {
					$props['url'] = html_entity_decode(forum_buildForumPostURL($id));
                } else {
					$props['url'] = html_entity_decode(forum_buildForumPostURL($A['id']));
                }
                break;
            default:
                // return empty string for unknown properties
                $props[$p] = '';
                break;
            }
        }

        $mapped = array();
        foreach ($props as $key => $value) {
            if ($id == '*') {
                if ($value != '') {
                    $mapped[$key] = $value;
                }
            } else {
                $mapped[] = $value;
            }
        }

        if ($id == '*') {
            $retval[] = $mapped;
        } else {
            $retval = $mapped;
            break;
        }
    }

    if (($id != '*') && (count($retval) == 1)) {
        $retval = $retval[0];
    }

    return $retval;
}

/**
* Delete a forum post and everything associated with it.
* Assumed have permission to do this so check before hand.
*
* @param   id   	int     Id of forum post
* @return           boolean
*/
function forum_deleteForumPost($id)
{
	global $_TABLES;

	$result = DB_query("SELECT forum, pid FROM {$_TABLES['forum_topic']} WHERE id = $id");
	list($forum, $pid) = DB_fetchArray($result);

	if ($forum > 0) { // must exist
		$parentTopic = false;
		if ($pid == 0) {
			$parentTopic = true;
			$pid = $id;
		}
		DB_query("DELETE FROM {$_TABLES['forum_topic']} WHERE id = $id");

		PLG_itemDeleted($id, 'forum');

		if ($parentTopic) {
			// Deleting a parent topic requires removing as well
			TOPIC_deleteTopicAssignments(PLUGIN_NAME_FORUM, $id, TOPIC_TYPE_FORUM_TOPIC);

		   // Cycle through all replies and delete any likes
			$query = DB_query("SELECT id FROM {$_TABLES['forum_topic']} WHERE pid = $id");
			while ($A = DB_fetchArray($query)) {
				LIKES_deleteActions(PLUGIN_NAME_FORUM, LIKES_TYPE_FORUM_POST, $A['id']);
			}
			// Now lets delete those replies
			DB_query("DELETE FROM {$_TABLES['forum_topic']} WHERE pid = $id");

			// Remove any topic notifications and exemptions
			DB_query("DELETE FROM {$_TABLES['forum_watch']} WHERE topic_id = $id");
			DB_query("DELETE FROM {$_TABLES['forum_watch']} WHERE topic_id = -$id");
		}

		// Delete Likes for current message being deleted
		LIKES_deleteActions(PLUGIN_NAME_FORUM, LIKES_TYPE_FORUM_POST, $id);

		// Remove any lastviewed records in the log so that the new updated topic indicator will appear
		DB_query("DELETE FROM {$_TABLES['forum_log']} WHERE topic = $pid");

		gf_updateLastPost($forum, $pid);

		COM_rdfUpToDateCheck('forum'); // forum rss feeds update
		// Remove new block and centerblock cached items
		$cacheInstance = 'forum__newpostsblock_';
		CACHE_remove_instance($cacheInstance);
		$cacheInstance = 'forum__centerblock_';
		CACHE_remove_instance($cacheInstance);

		return true;
	} else {
		return false;
	}
}

/**
* Create URL for a forum post. Permissions are not checked and is assumed done before hand
*
* @param   id   	int     Id of forum post
* @param   query   	string  Extra url parameters (placed just before anchor)
* @param   order   	string  Empty string uses $CONF_FORUM['sort_order_asc'] or ASC or DESC
* @param   anchor  	boolean True will add hashtag id
* @return           string   A URL to the forum post
*/
function forum_buildForumPostURL($id, $query = '', $order = '', $anchor = true)
{
	global $_CONF, $CONF_FORUM, $_TABLES;

	$retval = '';

    // Check if the number of records was specified to show
    // Note: $CONF_FORUM['show_posts_perpage'] gets overridden in functions.inc with user setting
    if (empty($CONF_FORUM['show_posts_perpage'])) {
        $show = 10; // need to do this as for some reason show_posts_perpage is empty when forum plugin gets enabled
    } else {
        $show = $CONF_FORUM['show_posts_perpage'];
    }

	// Get parent topic id
	$id = (int) $id; // very basic check just to make sure SQL doesn't fail
	$pid = DB_getItem($_TABLES['forum_topic'], 'pid', "id = $id");
	if ($pid != '') { // If empty does not exist
		if ($pid == 0) {
			$pid = $id;
		}
		// Lets find position of post in the topic. Then we can calculate the page number
		if (empty($order)) {
			if ($CONF_FORUM['sort_order_asc']) {
				$order = 'ASC';
			} else {
				$order = 'DESC';
			}
		}
		$sql  = "(SELECT id FROM {$_TABLES['forum_topic']} WHERE id = $pid)"
			  . " UNION ALL (SELECT id FROM {$_TABLES['forum_topic']} WHERE pid = $pid)"
			  . " ORDER BY id $order";
		$result = DB_query($sql);
		$numRows = DB_numRows($result);
		$found = false;
		for ($i = 1; $i <= $numRows; $i++) {
			$A = DB_fetchArray($result);
			if ($id == $A['id']) {
				$found = true;
				break;
			}
		}

		$page = 1;
		if ($i > $show && $found) {
			$page =  $i / $show;
			// If no decimal then
			if ($page != floor($page)) {
				$page = floor($page) + 1;
			}
		}

		$page_url = '';
		if ($page > 1) {
			$page_url = "&amp;page=$page";
		}

		$hashtag = '';
		if ($anchor) {
			$hashtag = "#$id";
		}

		$retval = $_CONF['site_url'] . "/forum/viewtopic.php?showtopic=$pid$page_url$query$hashtag";
	}
	return $retval;
}

function phpblock_forum_newposts() {
    global $_CONF, $_USER, $_TABLES, $LANG_GF01, $LANG_GF02, $CONF_FORUM, $_USER;

    $post_limit = $CONF_FORUM['sideblock_numposts'];
    if ($CONF_FORUM['installed_version'] < 2.6) {
        return;
    }

	// Check is anonymous users can access and if not, regular user can access
	if ($CONF_FORUM['registration_required'] && !SEC_hasRights('forum.user')) {
        return;
    }

    $mode  = isset($_GET['mode'])  ? COM_applyFilter($_GET['mode'])  : '';
    $order = isset($_GET['order']) ? COM_applyFilter($_GET['order']) : '';

    if (DB_getItem($_TABLES['plugins'],'pi_enabled', 'pi_name="forum"')) {
        // Check if user has clicked on a sort option in the block
        if ($mode == 'forumblock') {
            if (($order == 'new') OR ($order == '')) {
                $view_modemsg = sprintf($LANG_GF02['msg74'],$post_limit);
                if ($CONF_FORUM['sb_latestpostonly']) {
                    $orderby = 'lastupdated';
                } else {
                    $orderby = 'date';
                }
            } elseif ($order == 'views') {
                $view_modemsg = sprintf($LANG_GF02['msg75'],$post_limit);
                $orderby = 'views';
            } elseif ($order == 'posts') {
                $view_modemsg = sprintf($LANG_GF02['msg76'],$post_limit);
                $orderby = 'replies';
            } else { // garbage orderby so just default
                $orderby = 'date';
            }
        } else {
            $view_modemsg = sprintf($LANG_GF02['msg74'],$post_limit);
                if ($CONF_FORUM['sb_latestpostonly']) {
                    $orderby = 'lastupdated';
                } else {
                    $orderby = 'date';
                }
        }

        $cacheInstance = 'forum__newpostsblock_' . $orderby  . '_' . CACHE_security_hash() . '_' . $_CONF['theme'];
        $retval = CACHE_check_instance($cacheInstance);
        if ($retval) {
            return $retval;
        }

        $block = COM_newTemplate(CTL_plugin_templatePath('forum', 'blocks'));
        $block->set_file (array ('block'=>'latestpostsblock.thtml'));

        $block->set_block('block', 'block_record');

        $block->set_var ('phpself', $_CONF['site_url'] .'/index.php');
        $block->set_var ('layout_url', $CONF_FORUM['layout_url']);
        $block->set_var ('LANG_ORDERBY', $LANG_GF01['ORDERBY']);
        $block->set_var ('LANG_NEW', $LANG_GF01['NEW']);
        $block->set_var ('LANG_VIEWS', $LANG_GF01['VIEWS']);
        $block->set_var ('LANG_POSTS', $LANG_GF01['POSTS']);
        $block->set_var ('view_modemsg', $view_modemsg);

        // Select SQL to either show the latest posts even if they are for the same topic
        // Or show only the latest post for each of the last updated topics
        if ($CONF_FORUM['sb_latestpostonly']) {
            $sql = "SELECT a.id,a.forum,a.name,a.date,a.subject,a.replies,a.views,a.uid,a.pid FROM {$_TABLES['forum_topic']} a ";
            $sql .= "LEFT JOIN {$_TABLES['forum_forums']} b ON a.forum=b.forum_id ";
            $sql .= "WHERE a.pid=0 AND b.no_newposts = 0 ORDER BY $orderby DESC";
            $result = DB_query($sql);
        } else {
            $sql = "SELECT a.id,a.forum,a.name,a.date,a.subject,a.replies,a.views,a.uid,a.pid FROM {$_TABLES['forum_topic']} a ";
            $sql .= "LEFT JOIN {$_TABLES['forum_forums']} b ON a.forum=b.forum_id ";
            $sql .= "WHERE b.no_newposts = 0 ORDER BY $orderby DESC";
            $result = DB_query($sql);
        }

        $nrows  = DB_numrows($result);
        if ($nrows == 0) {
            return;
        }
        $onetwo = 1;
        $displaycount = 0;

        for ($i =1; $i <= $nrows; $i++) {

            $A = DB_fetchArray($result,false);
            if (trim($A['subject']) == '') {
                $A['subject'] = DB_getItem($_TABLES['forum_topic'],'subject',"id='{$A['pid']}'");
            }

            $fresult = DB_query ("SELECT grp_id, no_newposts FROM {$_TABLES['forum_forums']} WHERE forum_id='{$A['forum']}'");
            list ($grp_id, $no_newposts) = DB_fetchArray ($fresult);
            $groupname = DB_getItem($_TABLES['groups'],'grp_name',"grp_id='$grp_id'");

            if ($no_newposts==0 AND (SEC_inGroup($groupname) OR $grp_id == 2)) {
                $displaycount++;
                $fullsubject = $A['subject'];
                if (strlen ($A['subject']) > $CONF_FORUM['sb_subject_size']) {
                    $A['subject'] = COM_truncate($A['subject'], $CONF_FORUM['sb_subject_size'], '..');
                    $profilelink = '';
                }

                if ($A['replies'] > 0 AND $CONF_FORUM['sb_latestpostonly']) {
                    $lastreplySQL = DB_query("SELECT uid,name,date FROM {$_TABLES['forum_topic']} WHERE pid={$A['id']} ORDER BY date DESC LIMIT 1");
                    list ($uid,$postername,$postdate) = DB_fetchArray($lastreplySQL);
                } else {
                    $postername = $A['name'];
                    $postdate = $A['date'];
                    $uid = $A['uid'];
                }
                if ($uid > 1) {
                    $postername = COM_getDisplayName($uid);
                    $profilelink = "<a href='{$_CONF['site_url']}/users.php?mode=profile&amp;uid={$uid}'>";
                } else {
                    $profilelink = '';
                }

                if ($profilelink != '') {
                    $postername = $profilelink . $postername . '</a>';
                }

                $block->set_var ('css_id', $onetwo);
                $block->set_var ('img_dir', $CONF_FORUM['imgset']);
                $block->set_var ('forum_id', $A['forum']);
                $block->set_var ('forum_name', DB_getItem($_TABLES['forum_forums'],'forum_name',"forum_id='{$A['forum']}'"));
				$block->set_var ('postURL', forum_buildForumPostURL($A['id']));
                $block->set_var ('topic_id', $A['id']);
                $block->set_var ('topic_subject', $A['subject']);
                $block->set_var ('fullsubject', $fullsubject);
                $block->set_var ('topic_id', $A['id']);
                $block->set_var ('user_name', $postername);
                $block->set_var ('LANG_BY', $LANG_GF01['BY']);
                $block->set_var ('LANG_ON', $LANG_GF01['ON']);
                $block->set_var ('LANG_VIEWS', $LANG_GF01['VIEWS']);
                $block->set_var ('LANG_REPLIES', $LANG_GF01['REPLIES']);
                $block->set_var ('views', COM_numberFormat($A['views']));
                $block->set_var ('replies', COM_numberFormat($A['replies']));
                if ($CONF_FORUM['allow_user_dateformat']) {
                    $date = COM_getUserDateTimeFormat ($postdate);
                    $block->set_var ('date', $date[0]);
                } else {
                    $block->set_var ('date', strftime($CONF_FORUM['default_Datetime_format'], $postdate));
                }

                $block->parse ('block_record', 'block_record',true);

                if ($onetwo == 1) {
                    $onetwo = 2;
                } else {
                    $onetwo = 1;
                }
                if ($displaycount >= $CONF_FORUM['sideblock_numposts']) {
                    break;
                }
            }
        }

        if ($displaycount == 0) {
            return;
        }

        $block->parse ('output', 'block');
        $retval = $block->finish($block->get_var('output'));

        CACHE_create_instance($cacheInstance, $retval);

        return $retval;
    } else {
        return;
    }
}


/**
* Display latest forum posts in the center block.
*
* @param   where   int      where the block will be displayed (0..2)
* @param   page    int      page number
* @param   topic   string   topic ID
* @return          string   HTML for the center block (can be empty)
*/
function plugin_centerblock_forum ($where = 1, $page = 1, $topic = '')
{
    global $_CONF, $_USER, $_TABLES, $LANG_GF01, $CONF_FORUM;
    global $LANG_GF02, $mode, $order, $_USER;

    //$TIMER = new timerobject();
    //$TIMER->startTimer();
    //$exectime = $TIMER->stopTimer();

    if ($CONF_FORUM['installed_version'] < 2.6) {
        return;
    }

	// Check is anonymous users can access and if not, regular user can access
    // if ($CONF_FORUM['registration_required'] && $_USER['uid'] < 2) {
	if ($CONF_FORUM['registration_required'] && !SEC_hasRights('forum.user')) {
        return;
    }

    $retval = '';

    if (!$CONF_FORUM['show_centerblock']) {
        return;
    }

    $cb_enable = $CONF_FORUM['show_centerblock'];
    $cb_where  = $CONF_FORUM['centerblock_where'];


    // If enabled only for homepage and this is not page 1 or a topic page,
    // then set disable flag
    if ($CONF_FORUM['centerblock_homepage'] == 1 AND ($page > 1 OR !empty ($topic))) {
        $cb_enable = 0;
    } elseif ($CONF_FORUM['centerblock_homepage'] == 0 and $page > 1) {
        $cb_where = 1;      // Top of Page
    }

    // Check if there are no featured articles in this topic
    // and if so then place it at the top of the page
    if (!empty ($topic)) {
        $fromsql = ", {$_TABLES['topic_assignments']} ta";
        $wheresql = "WHERE ta.id = sid AND ta.tid='$topic' AND featured > 0";
    } else {
        $fromsql = '';
        $wheresql = 'WHERE featured = 1';
    }
    $query = DB_query ("SELECT COUNT(*) AS count FROM {$_TABLES['stories']} $fromsql $wheresql");
    $result = DB_fetchArray ($query);
    if ($result['count'] == 0 and $cb_where == 2) {
        $cb_where = 1;
    }

    if (!$cb_enable OR $cb_where != $where) {
        return;
    }

    $cacheInstance = 'forum__centerblock' . '_' . CACHE_security_hash() . '_' . $_CONF['theme'];
    $retval = CACHE_check_instance($cacheInstance);
    if ($retval) {
        return $retval;
    }

    $block = COM_newTemplate(CTL_plugin_templatePath('forum', 'blocks'));
    $block->set_file (array ('block' => 'centerblock.thtml'));

    $block->set_block('block', 'block_record');

    $block->set_var ('phpself', $_CONF['site_url'] .'/index.php');
    $block->set_var ('startblock', COM_startBlock($LANG_GF02['msg170']));
    $block->set_var ('endblock', COM_endBlock());
    $block->set_var ('layout_url', $CONF_FORUM['layout_url']);
    $block->set_var ('LANG_title', $LANG_GF02['msg170']);
    $block->set_var ('LANG_FORUM', $LANG_GF01['FORUM']);
    $block->set_var ('LANG_TOPIC', $LANG_GF01['TOPIC']);
    $block->set_var ('LANG_LASTPOST', $LANG_GF01['LASTPOST']);
    $block->set_var ('LANG_NEWPOST', $LANG_GF01['NEWPOSTS']);

    $block->set_var ('LANG_viewlastpost', $LANG_GF02['msg160']);
    $block->set_var ('LANG_forumjump', $LANG_GF02['msg195']);

    $groups = array ();
    $usergroups = SEC_getUserGroups();
    foreach ($usergroups as $group) {
        $groups[] = $group;
    }
    $grouplist = implode(',',$groups);

    $sql  = "SELECT a.id, a.forum, a.name, a.date, a.lastupdated, a.last_reply_rec, a.subject, ";
    $sql .= "a.comment, a.uid, a.name, a.pid, a.replies, a.views, b.forum_name  ";
    $sql .= "FROM {$_TABLES['forum_topic']} a ";
    $sql .= "LEFT JOIN {$_TABLES['forum_forums']} b ON a.forum=b.forum_id ";
    $sql .= "WHERE pid=0 AND b.grp_id IN ($grouplist) AND b.no_newposts = 0 ";
    $sql .= "ORDER BY lastupdated DESC LIMIT {$CONF_FORUM['centerblock_numposts']}";
    $result = DB_query ($sql);

    if (DB_numRows($result) == 0) {
        return;
    }

    $f_tooltip = function_exists('COM_getTooltip');
    $cssid = 0;
    while ($A = DB_fetchArray ($result)) {
        $fullsubject = "{$A['subject']}\n{$LANG_GF01['POSTEDBY']}:{$A['name']}{$LANG_GF01['VIEWS']}:" . COM_numberFormat($A['views']) . ", {$LANG_GF01['REPLIES']}:" . COM_numberFormat($A['replies']);
        if (($CONF_FORUM['cb_subject_size'] > 0) AND (strlen ($A['subject']) > $CONF_FORUM['cb_subject_size'])) {
            $A['subject'] = COM_truncate($A['subject'], $CONF_FORUM['cb_subject_size'], '...');
        }

        if ($CONF_FORUM['allow_user_dateformat']) {
            $firstdate = COM_getUserDateTimeFormat ($A['date']);
            $firstdate = $firstdate[0];
            $lastdate = COM_getUserDateTimeFormat ($A['lastupdated']);
            $lastdate = $lastdate[0];
        } else {
            $firstdate = strftime($CONF_FORUM['default_Datetime_format'], $A['date']);
            $lastdate = strftime($CONF_FORUM['default_Datetime_format'], $A['lastupdated']);
        }
        if ($A['uid'] > 1) {
            $topicinfo = htmlspecialchars($A['subject']) . "<br" . XHTML . ">{$LANG_GF01['STARTEDBY']} " . COM_getDisplayName($A['uid']) . ', ';
            $topicinfo_short = "{$LANG_GF01['STARTEDBY']} " . COM_getDisplayName($A['uid']) . ', ';
        } else {
            $topicinfo = htmlspecialchars($A['subject']) . "<br" . XHTML . ">{$LANG_GF01['STARTEDBY']} {$A['name']},";
            $topicinfo_short = "{$LANG_GF01['STARTEDBY']} {$A['name']}";
        }

        $topicinfo .= "{$firstdate}<br" . XHTML . ">{$LANG_GF01['VIEWS']}:" . COM_numberFormat($A['views']) . ", {$LANG_GF01['REPLIES']}:{$A['replies']}<br" . XHTML . ">";
        $topicinfo_short .= " &raquo; {$firstdate}";
        $repliesinfo = " {$LANG_GF01['REPLIES']}:" . COM_numberFormat($A['replies']);

        if (empty ($A['last_reply_rec']) OR $A['last_reply_rec'] < 1) {
            $lastid = $A['id'];
            $lastcomment = $A['comment'];
        } else {
            $qlreply = DB_query("SELECT id,uid,name,comment FROM {$_TABLES['forum_topic']} WHERE id={$A['last_reply_rec']}");
            $B = DB_fetchArray($qlreply);
            $lastid = $B['id'];
            $lastcomment = $B['comment'];
            if ($B['uid'] > 1) {
                $topicinfo .= sprintf($LANG_GF01['LASTREPLYBY'],COM_getDisplayName($B['uid']));
                $repliesinfo = sprintf($LANG_GF01['LASTREPLYBY'],COM_getDisplayName($B['uid'])) . " &raquo; $lastdate $repliesinfo";
            } else {
                $topicinfo .= sprintf($LANG_GF01['LASTREPLYBY'],$B['name']);
                $repliesinfo = sprintf($LANG_GF01['LASTREPLYBY'],$B['name']) . " &raquo; $lastdate $repliesinfo";
            }
        }

        $lastpostinfo = strip_tags(COM_truncate($lastcomment, $CONF_FORUM['contentinfo_numchars'], '...'));
        $lastpostinfo = forum_stripBBCode($lastpostinfo); // Simple function to strip out bbcode so tooltips display better
        $lastpostinfo = forum_mb_wordwrap($lastpostinfo, $CONF_FORUM['linkinfo_width'], LB);
        $lastpostinfo = htmlspecialchars($lastpostinfo); // Escape things like " so it displays properly in tooltip
        $lastpostinfo = str_replace(LB, "<br" . XHTML . ">", $lastpostinfo); // Do this last

        $cssid = ($cssid == 1) ? 2 : 1;

        if ($f_tooltip) {
            $block->set_var('gl-tooltip', true); // Used to verify gl tooltip is being set
			$lastpostlink = forum_buildForumPostURL($lastid);
            $block->set_var ('tooltip_date', COM_getTooltip($lastdate, $lastpostinfo, $lastpostlink));
			$topiclink = forum_buildForumPostURL($A['id']);
            $block->set_var ('tooltip_topic_subject', COM_getTooltip($A['subject'], $topicinfo, $topiclink));
        }

        $block->set_var ('lastpostinfo', $lastpostinfo);
        $block->set_var ('topicinfo', $topicinfo);
        $block->set_var ('topicinfo_short', $topicinfo_short);
        $block->set_var ('repliesinfo', $repliesinfo);
        $block->set_var ('date', $lastdate);
        $block->set_var ('topic_subject', $A['subject']);

        $block->set_var ('lastpostURL', forum_buildForumPostURL($lastid));
		$block->set_var ('lastpostid', $lastid);
        $block->set_var ('cssid', $cssid);
        $block->set_var ('img_dir', $CONF_FORUM['imgset']);
        $block->set_var ('forum_id', $A['forum']);
        $block->set_var ('forum_name', $A['forum_name']);
        $block->set_var ('topic_id', $A['id']);
        $block->set_var ('fullsubject', $fullsubject);
        $block->set_var ('views', COM_numberFormat($A['views']));
        $block->set_var ('replies', COM_numberFormat($A['replies']));
        $block->set_var ('lastpostby',$A['name']);
        $block->parse ('block_record', 'block_record',true);
    }

    $block->parse ('output', 'block');
    $retval .= $block->finish ($block->get_var ('output'));

    //$exectime = $TIMER->stopTimer();
    //COM_errorLog("Centerblock Execution Time: $exectime seconds");

    CACHE_create_instance($cacheInstance, $retval);

    return $retval;
}

function forum_stripBBCode($text_to_search) {
	// Replace paragraph tags
	$pattern = '[p]';
	$replace = LB;
	$text_to_search = str_replace($pattern, $replace, $text_to_search);
	$pattern = '[/p]';
	$replace = LB;
	$text_to_search = str_replace($pattern, $replace, $text_to_search);

	// Replace everything else with nothing
	$pattern = '|[[\/\!]*?[^\[\]]*?]|si';
	$replace = '';
	$text_to_search = preg_replace($pattern, $replace, $text_to_search);

	return $text_to_search;
}

/**
* Get header code for inclusion
*
* @return   string
*
*/
function plugin_getheadercode_forum()
{
    global $_SCRIPTS;

    $_SCRIPTS->setCSSFile('forum', CTL_plugin_themeFindFile('forum', 'css', 'forum.css'));

    // Look for forum templates functions.php for current theme. If exist add in its required javascript and css
    CTL_plugin_setTemplatesFunctions("forum");
}

/**
* Provide URL of a documentation file
*
* @param    string  $file   documentation file being requested, e.g. 'config'
* @return   mixed           URL or false when not available
*
*/
function plugin_getdocumentationurl_forum($file)
{
    global $_CONF;

    static $docurl;

    switch ($file) {
    case 'index':
    case 'config':
        if (isset($docurl)) {
            $retval = $docurl;
        } else {
            $doclang = COM_getLanguageName();
            $docs = 'forum/docs/' . $doclang . '/forum.html';
            if (file_exists($_CONF['path_html'] . $docs)) {
                $retval = $_CONF['site_url'] . '/' . $docs;
            } else {
                $retval = $_CONF['site_url'] . '/forum/docs/english/forum.html';
            }
            $docurl = $retval;
        }
        break;

    default:
        $retval = false;
        break;
    }

    return $retval;
}

/**
* See if topic, forum or category has a Geeklog topic assigned to it and set
*
* @param    int     $type   If it is a topic, forum, or category
* @param    int     $id     Id of forum item
*
* @return
*
*/
function forum_getGeeklogTopic($type, $id) {
    global $_TABLES;

    // If topic assignment not found at current level then check next higher level
    switch ($type) {
        case TOPIC_TYPE_FORUM_TOPIC:
            TOPIC_getTopic(PLUGIN_NAME_FORUM, $id, TOPIC_TYPE_FORUM_TOPIC);
            $current_topic = TOPIC_currentTopic();

            if (empty($current_topic)) {
                $id = DB_getItem($_TABLES['forum_topic'],"forum","id=$id");
            } else {
                break;
            }

        case TOPIC_TYPE_FORUM_FORUM:
            TOPIC_getTopic(PLUGIN_NAME_FORUM, $id, TOPIC_TYPE_FORUM_FORUM);
            $current_topic = TOPIC_currentTopic(); // since TOPIC_getTopic called again need to get current topioc again since it may have changed

            if (empty($current_topic)) {
                $id = DB_getItem($_TABLES['forum_forums'],"forum_cat","forum_id=$id");
            } else {
                break;
            }

        case TOPIC_TYPE_FORUM_CATEGORY:
            TOPIC_getTopic(PLUGIN_NAME_FORUM, $id, TOPIC_TYPE_FORUM_CATEGORY);

        default:
            $current_topic = TOPIC_currentTopic(); // since TOPIC_getTopic called again need to get current topioc again since it may have changed

            if (empty($current_topic) AND !empty($CONF_FORUM['topic_default'])) {
                TOPIC_setTopic($CONF_FORUM['topic_default']);
            }
    }

}

// Show Topic assignment label to forum admins and mods and if it was a directly assigned or inherited
function forum_getGeeklogTopicLabel($sub_type, $id) {
    global $CONF_FORUM, $_TABLES, $LANG21, $LANG_GF02;

    $retval = '';
    $end = 3;
    $have_id = true;

    switch ($sub_type) {
        case TOPIC_TYPE_FORUM_TOPIC:
            $start = 1;
            break;

        case TOPIC_TYPE_FORUM_FORUM:
            $start = 2;
            break;

        case TOPIC_TYPE_FORUM_CATEGORY:
            $start = 3;
            break;
    }

    $lang_inherited = '';
    for($i = $start; $i <= $end; ++$i) {
        switch ($i) {
            case 2:
                if (!$have_id) {
                    $sub_type = TOPIC_TYPE_FORUM_FORUM;
                    $id = DB_getItem($_TABLES['forum_topic'],"forum","id=$id");
                }
                break;

            case 3:
                if (!$have_id) {
                    $sub_type = TOPIC_TYPE_FORUM_CATEGORY;
                    $id = DB_getItem($_TABLES['forum_forums'],"forum_cat","forum_id=$id");
                }
                break;
        }

        $sql = "SELECT t.tid, t.topic FROM {$_TABLES['topics']} t, {$_TABLES['topic_assignments']} ta
                WHERE t.tid = ta.tid
                AND ta.type = '" . PLUGIN_NAME_FORUM . "'
                AND ta.subtype = '" . $sub_type . "' AND ta.id = '" . $id . "'" . COM_getPermSQL('AND', 0, 2, 't');

        $result = DB_query($sql);
        $nrows  = DB_numRows($result);
        if ($nrows == 0) {
            // $retval = $LANG21[47]; // None
        } elseif($nrows == 1) {
            list ($tid,$topic_name) = DB_fetchARRAY($result);
            $retval = $topic_name;
        } else {
            $retval = $LANG21[44]; // Multiple
        }

        if (!empty($retval)) {
            // See if inherited and from where
            if ($i != $start AND $i == 2) {
                $retval = sprintf($LANG_GF02['gl_topics_inherit_forum'], $retval);
            } elseif ($i != $start AND $i == 3) {
                $retval = sprintf($LANG_GF02['gl_topics_inherit_category'], $retval);
            }

            break;
        } else {
            $have_id = false;
        }
    }

    if (empty($retval) AND !empty($CONF_FORUM['gl_topic_default']) AND $CONF_FORUM['gl_topic_default'] != TOPIC_ALL_OPTION) {
        $sql = "SELECT tid, topic FROM {$_TABLES['topics']}
                WHERE tid = '" . $CONF_FORUM['gl_topic_default'] . "'" . COM_getPermSQL('AND');

        $result = DB_query($sql);
        $nrows  = DB_numRows($result);
        if ($nrows == 1) {
            $A = DB_fetchArray($result);
            $retval = sprintf($LANG_GF02['gl_topics_inherit_config'], $A['topic']);
        }
    }

    return $retval;
}

/**
* Provides text for a Configuration tooltip
*
* @param    string  $id     Id of config value
* @return   mixed           Text to use regular tooltip, NULL to use config
*                           tooltip hack, or empty string when not available
*
*/
function plugin_getconfigtooltip_forum($id)
{
    // Use config tooltip hack where tooltip is read from the config documentation
    return;
}

// +---------------------------------------------------------------------------+
// | Commmon Forum Functions                                                   |
// +---------------------------------------------------------------------------+

function forum_modPermission($forum = '', $uid = '', $permission = '') {
    global $_USER,$_TABLES;

    if ($uid == '') {
        if (isset($_USER['uid'])) {
            $uid = $_USER['uid'];
        } else {
            return FALSE;  // Invalid ID or anonymous user
        }
    }

    if ($uid <= 1) {
        return FALSE;  // Invalid ID or anonymous user
    }

	if (SEC_inGroup('Root', $uid)) {
		return TRUE;
	}

    if (SEC_hasRights('forum.edit', '', $uid)) {
        // If user is part of forum Admin user group then he should automatically be assumed a moderator
        return TRUE;
    } else {
		/* Retrieve all moderator records for this forum */
		if (empty($forum)) {
			// See if user is a moderator of anything...
			$forumSQL = '';
		} else {
			/* Retrieve all moderator records for this forum */
			$forumSQL = " WHERE mod_forum='$forum'";
		}
		$sql = "SELECT * FROM {$_TABLES['forum_moderators']}{$forumSQL}";
        $modrecords = DB_query($sql);
        while ($A = DB_fetchArray($modrecords)) {
            if ($A['mod_groupid'] > 0) {
                if (SEC_inGroup($A['mod_groupid'], $uid)) {
                    if ($permission != '') {
                        if ($A[$permission] == '1') {
                            return TRUE;
                        }
                    } else {
                        return TRUE;
                    }
                }
            } else {
                if ($A['mod_uid'] == $uid) {
                    if ($permission != '') {
                        if ($A[$permission] == '1') {
                            return TRUE;
                        }
                    } else {
                        return TRUE;
                    }
                }
            }
        }
    }

    /* If I get this far then I exited the loop without finding a permission record */
    return FALSE;

}


/**
* Gets Geeklog blocks from plugins
*
* Returns data for blocks on a given side and, potentially, for
* a given topic.
*
* @param    string  $side   Side to get blocks for (right or left for now)
* @param    string  $topic  Only get blocks for this topic
* @return   array           array of block data
* @link     http://wiki.geeklog.net/index.php/Dynamic_Blocks
*
*/
function plugin_getBlocks_forum($side, $topic='')
{
    global $_TABLES, $_CONF, $CONF_FORUM, $LANG_GF01;

    $retval = array();

    $owner_id = SEC_getDefaultRootUser();

    // Forum Posts Block
    // Check permissions first
    if ($CONF_FORUM['sideblock_enable'] && SEC_hasAccess($owner_id, $CONF_FORUM['sideblock_group_id'], $CONF_FORUM['sideblock_permissions'][0], $CONF_FORUM['sideblock_permissions'][1], $CONF_FORUM['sideblock_permissions'][2], $CONF_FORUM['sideblock_permissions'][3])) {
        // Check if right topic
        if (($CONF_FORUM['sideblock_topic_option'] == TOPIC_ALL_OPTION) || ($CONF_FORUM['sideblock_topic_option'] == TOPIC_HOMEONLY_OPTION && COM_onFrontpage()) || ($CONF_FORUM['sideblock_topic_option'] == TOPIC_SELECTED_OPTION && in_array($topic, $CONF_FORUM['sideblock_topic']))) {
            if (($side=='left' && $CONF_FORUM['sideblock_isleft'] == 1) || ($side=='right' && $CONF_FORUM['sideblock_isleft'] == 0)) {
                // Create a block
                $display = phpblock_forum_newposts();

                $retval[] = array('name'           => 'forum_posts',
                                  'type'           => 'dynamic',
                                  'onleft'         => $CONF_FORUM['sideblock_isleft'],
                                  'title'          => $LANG_GF01['FORUMPOSTS'],
                                  'blockorder'     => $CONF_FORUM['sideblock_order'],
                                  'content'        => $display,
                                  'allow_autotags' => false,
                                  'convert_newlines' => false,
								  'css_id' 		   => 'gl-blockForumNewPosts', // Used to jump to block position when user changes order of forum posts in block
                                  'help'           => '');

            }
        }
    }

    // Forum Menu Block
    if ($CONF_FORUM['usermenu'] == 'blockmenu' && $CONF_FORUM['add_forum_menu_check']) {
        if (($side=='left' && $CONF_FORUM['menublock_isleft'] == 1) || ($side=='right' && $CONF_FORUM['menublock_isleft'] == 0)) {
            // Create a block
            $display = phpblock_forum_menu();

            $retval[] = array('name'           => 'forum_menu',
                              'type'           => 'dynamic',
                              'onleft'         => $CONF_FORUM['menublock_isleft'],
                              'title'          => $LANG_GF01['FORUMMENU'],
                              'blockorder'     => $CONF_FORUM['menublock_order'],
                              'content'        => $display,
                              'allow_autotags' => false,
                              'convert_newlines' => false,
                              'help'           => '');

        }
    }

    return $retval;
}

/**
* Gets config information for dynamic blocks from plugins
*
* Returns data for blocks on a given side and, potentially, for
* a given topic.
*
* @param    string  $side   Side to get blocks for (right or left for now)
* @param    string  $topic  Only get blocks for this topic
* @return   array           array of block data
* @link     http://wiki.geeklog.net/index.php/Dynamic_Blocks
*
*/
function plugin_getBlocksConfig_forum($side, $topic='')
{
    global $_TABLES, $_CONF, $CONF_FORUM, $LANG_GF01;

    $retval = array();

    $owner_id = SEC_getDefaultRootUser();

    // Forum Posts Block
    // Check permissions first
    if (SEC_hasAccess($owner_id, $CONF_FORUM['sideblock_group_id'], $CONF_FORUM['sideblock_permissions'][0], $CONF_FORUM['sideblock_permissions'][1], $CONF_FORUM['sideblock_permissions'][2], $CONF_FORUM['sideblock_permissions'][3])) {
        if (($side=='left' && $CONF_FORUM['sideblock_isleft'] == 1) || ($side=='right' && $CONF_FORUM['sideblock_isleft'] == 0)) {
            $retval[] = array('plugin'         => $LANG_GF01['FORUM'],
                              'name'           => 'forum_posts',
                              'title'          => $LANG_GF01['FORUMPOSTS'],
                              'type'           => 'dynamic',
                              'onleft'         => $CONF_FORUM['sideblock_isleft'],
                              'blockorder'     => $CONF_FORUM['sideblock_order'],
                              'allow_autotags' => false,
                              'convert_newlines' => false,
                              'help'           => '',
                              'enable'         => $CONF_FORUM['sideblock_enable'],
                              'topic_option'   => $CONF_FORUM['sideblock_topic_option'],
                              'topic'          => $CONF_FORUM['sideblock_topic'],
                              'inherit'        => array()
                              );
        }
    }

    // Forum Menu Block
    if (($side=='left' && $CONF_FORUM['menublock_isleft'] == 1) || ($side=='right' && $CONF_FORUM['menublock_isleft'] == 0)) {

        if ($CONF_FORUM['usermenu'] == 'blockmenu') {
            $menublock_enable = 1;
        } else {
            $menublock_enable = 0;
        }

        $retval[] = array('plugin'         => $LANG_GF01['FORUM'],
                          'name'           => 'forum_menu',
                          'title'          => $LANG_GF01['FORUMMENU'],
                          'type'           => 'dynamic',
                          'onleft'         => $CONF_FORUM['menublock_isleft'],
                          'blockorder'     => $CONF_FORUM['menublock_order'],
                          'allow_autotags' => false,
                          'convert_newlines' => false,
                          'help'           => '',
                          'enable'         => $menublock_enable,
                          'topic_option'   => '',
                          'topic'          => array(),
                          'inherit'        => array()
                          );
    }

    return $retval;
}

function forum_mb_wordwrap($str, $width, $break)
{
    static $mb_enabled;

    if (!isset($mb_enabled)) {
        $mb_enabled = MBYTE_checkEnabled();
    }
    if (!$mb_enabled) {
        return wordwrap($str, $width, $break);
    }

   // Return short or empty strings untouched
    if(empty($str) || mb_strlen($str, 'UTF-8') <= $width)
        return $str;

    $br_width  = mb_strlen($break, 'UTF-8');
    $str_width = mb_strlen($str, 'UTF-8');
    $return = '';
    $last_space = false;

    for($i = 0, $count = 0; $i < $str_width; $i++, $count++) {
        // If we're at a break
        if (mb_substr($str, $i, $br_width, 'UTF-8') == $break) {
            $count = 0;
            $return .= mb_substr($str, $i, $br_width, 'UTF-8');
            $i += $br_width - 1;
            continue;
        }

        // Keep a track of the most recent possible break point
        if(mb_substr($str, $i, 1, 'UTF-8') == " ") {
            $last_space = $i;
        }

        // It's time to wrap
        if ($count > $width) {
            // There are no spaces to break on!  Going to truncate :(
            if(!$last_space) {
                $return .= $break;
                $count = 0;
            } else {
                // Work out how far back the last space was
                $drop = $i - $last_space;

                // Cutting zero chars results in an empty string, so don't do that
                if($drop > 0) {
                    $return = mb_substr($return, 0, -$drop);
                }

                // Add a break
                $return .= $break;

                // Update pointers
                $i = $last_space + ($br_width - 1);
                $last_space = false;
                $count = 0;
            }
        }

        // Add character from the input string to the output
        $return .= mb_substr($str, $i, 1, 'UTF-8');
    }
    return $return;
}

function gf_showVariables()
{
    global $CONF_FORUM;

    if (!$CONF_FORUM['debug']) return '';

    ob_start();
    if (!empty($_POST)) {
        echo COM_startBlock("_POST");
        var_dump($_POST);
        echo COM_endBlock();
    }
    if (!empty($_GET)) {
        echo COM_startBlock("_GET");
        var_dump($_GET);
        echo COM_endBlock();
    }
    if (!empty($_FILES)) {
        echo COM_startBlock("_FILES");
        var_dump($_FILES);
        echo COM_endBlock();
    }
    $retval = ob_get_contents();
    ob_end_clean();

    return $retval;
}

// +---------------------------------------------------------------------------+
// | Forum's OWN Plugin API Functions                                          |
// +---------------------------------------------------------------------------+

/**
 * This function returns the HTML code for displaying
 * the list of available smilies when posting a topic
 */
function forumPLG_showsmilies() {
    global $_SMILIES;
    // Let the ForumSmilies class handle this
    return $_SMILIES->show();
}

function forumPLG_restoreEmoticons($str) {
    global $CONF_FORUM;

    // Check and see if glMessenger is installed
    if (function_exists('msg_showsmilies')) {
        return msg_restoreEmoticons($str);
    } else {
        require_once $CONF_FORUM['path_include'] . 'gf_format.php';
        forum_xchsmilies($str);
    }
}

function forumPLG_getPMlink($member) {
    global $_TABLES,$_CONF;
    if (DB_getItem($_TABLES['plugins'],'pi_enabled',"pi_name='messenger'") == 1) {
        return "{$_CONF['site_url']}/messenger/index.php?action=newpm&amp;toname={$member};";
    } else {
        return '';
    }
}

function forumPLG_getMemberBadge($uid) {
    global $_CONF,$CONF_FORUM;

    $memberbadge = COM_newTemplate(CTL_plugin_templatePath('forum'));
    $memberbadge->set_file (array('forum_icons' => 'forum_icons.thtml'));

	$memberbadge->set_block('forum_icons', 'memberbadge_icon');

	$memberbadge->set_var ('imgset', $CONF_FORUM['imgset']);

    if ($uid > 1) {
        if (!SEC_inGroup('Root',$uid)) {
            foreach ($CONF_FORUM['grouptags'] as $groupid => $buttonimg) {
                if (SEC_inGroup($groupid,$uid)) {
					$memberbadge->set_var ('buttonimg', $buttonimg);
					$memberbadge->set_var ('memberbadgetitle', $CONF_FORUM['groupnames'][$groupid]);

					return $memberbadge->parse ('output', 'memberbadge_icon');
                }
            }
        } else {
			$memberbadge->set_var ('buttonimg', $CONF_FORUM['grouptags']['Root']);
			$memberbadge->set_var ('memberbadgetitle', $CONF_FORUM['groupnames']['Root']);

			return $memberbadge->parse ('output', 'memberbadge_icon');
        }
    }
}

/* GL-Menu 2.5 version of the Forum Menu */
function phpblock_forum_menu() {
    global $_TABLES,$_CONF,$_USER,$CONF_FORUM,$LANG_GF01,$LANG_GF02,$LANG_GF07,$CONF_GLMENU,$_BLOCK_TEMPLATE;

    $retval = '';
    if (isset($CONF_GLMENU) AND $CONF_GLMENU['installed_version'] >= 2.5) {
        if ($CONF_GLMENU['milonicmode']) {
            $retval = COM_startBlock( $LANG_GF00['forumblock'], '', 'glmenu/milonicmenu/blockheader-blockmenu.thtml');
            $retval .= 'aI("text='.$LANG_GF01['INDEXPAGE'].';url='.$_CONF['site_url'].'/forum/index.php;");' . LB;
            if (!COM_isAnonUser()) {
                $retval .= 'aI("text='.$LANG_GF01['USERPREFS'].';url='.$_CONF['site_url'].'/forum/userprefs.php;");' . LB;
                $retval .= 'aI("text='.$LANG_GF01['SUBSCRIPTIONS'].';url='.$_CONF['site_url'].'/forum/notify.php;");' . LB;
            }
            $retval .= 'aI("text='.$LANG_GF02['msg88'].';url='.$_CONF['site_url'].'/forum/memberlist.php;");' . LB;
            $retval .= 'aI("text='.$LANG_GF07['3'].';url='.$_CONF['site_url'].'/forum/index.php?op=popular;");' . LB;
            $retval .= COM_endBlock('glmenu/milonicmenu/blockfooter-blockmenu.thtml');
        } else {
            $retval = COM_startBlock( $LANG01[47], '', 'glmenu/blockheader.thtml');
            $t = COM_newTemplate($_CONF['path_layout'] . 'glmenu/cssmenu');
            $t->set_file('menu','blockmenu.thtml');
            $links = "<li><a href=\"{$_CONF['site_url']}/forum/index.php\" title=\"{$LANG_GF02['msg196']}\">{$LANG_GF01['INDEXPAGE']}</a></li>" . LB;
            if (!COM_isAnonUser()) {
                $links .= "<li><a href=\"{$_CONF['site_url']}/forum/index.php?op=markallread\" title=\"{$LANG_GF02['msg197']}\">{$LANG_GF01['MARKALLREAD']}</a></li>" . LB;
                $links .= "<li><a href=\"{$_CONF['site_url']}/forum/userprefs.php\" title=\"{$LANG_GF02['msg198']}\">{$LANG_GF01['USERPREFS']}</a></li>" . LB;
                $links .= "<li><a href=\"{$_CONF['site_url']}/forum/notify.php\" title=\"{$LANG_GF02['msg199']}\">{$LANG_GF01['SUBSCRIPTIONS']}</a></li>" . LB;
            }
            if (($CONF_FORUM['show_memberslist_anonymous'] && COM_isAnonUser()) OR !COM_isAnonUser()) {
            	$links .= "<li><a href=\"{$_CONF['site_url']}/forum/memberlist.php\" title=\"{$LANG_GF02['msg200']}\">{$LANG_GF02['msg88']}</a></li>" . LB;
			}
            $links .= "<li><a href=\"{$_CONF['site_url']}/forum/index.php?op=popular\" title=\"{$LANG_GF02['msg201']}\">{$LANG_GF07['3']}</a></li>" . LB;

            $t->set_var('menuitems', $links);
            $t->parse ('output', 'menu');
            $retval .= $t->finish ($t->get_var('output'));
            $retval .= COM_endBlock('glmenu/blockfooter.thtml');
        }
    } else {
        $base = $_CONF['site_url'] . '/forum/';
        $items = array();
        $items[] = COM_createLink($LANG_GF01['INDEXPAGE'], $base.'index.php', array('title' => $LANG_GF02['msg196']));
        if (!COM_isAnonUser()) {
            $items[] = COM_createLink($LANG_GF01['MARKALLREAD'], $base.'index.php?op=markallread',
                       array('title' => $LANG_GF02['msg197'], 'onclick' => 'return confirm(\'' . $LANG_GF02['msg301'] . '\');'));
            $items[] = COM_createLink($LANG_GF01['USERPREFS'], $base.'userprefs.php', array('title' => $LANG_GF02['msg198']));
            $items[] = COM_createLink($LANG_GF01['SUBSCRIPTIONS'], $base.'notify.php', array('title' => $LANG_GF02['msg199']));
        }
        if (($CONF_FORUM['show_memberslist_anonymous'] && COM_isAnonUser()) OR !COM_isAnonUser()) {
        	$items[] = COM_createLink($LANG_GF02['msg88'], $base.'memberlist.php', array('title' => $LANG_GF02['msg200']));
		}
        $items[] = COM_createLink($LANG_GF07['3'], $base.'index.php?op=popular', array('title' => $LANG_GF02['msg201']));
        $retval .= COM_makeList($items, PLG_getThemeItem('forum-css-list-menu', 'forum'));
    }

    return $retval;
}


function glmenu_showforums() {
    global $_CONF,$_TABLES,$CONF_GLMENU;

    $retval = '';
    $glMenu_version = DB_getItem($_TABLES['plugins'],'pi_version',"pi_name = 'glmenu'");
    $qforums = DB_query("SELECT forum_name,forum_id,grp_id FROM {$_TABLES['forum_forums']} ORDER BY forum_cat, forum_order ASC");
    while (list($forum_name,$forum_id, $forum_grp) = DB_fetchArray($qforums)) {
        $groupname = DB_getItem($_TABLES['groups'],'grp_name',"grp_id='$forum_grp'");
        if (SEC_inGroup($groupname)) {
            if ($CONF_GLMENU['milonicmode']) {
                $retval .= 'aI("text='.$forum_name.';url='.$_CONF['site_url'].'/forum/index.php?forum='.$forum_id.';");';
            } else {
                $retval .= "<li><a href=\"{$_CONF['site_url']}/forum/index.php?forum={$forum_id}\">$forum_name</a></li>";
            }
        }
    }
    return $retval;
}


/**
* This function is called to inform plugins when a group's information has
* changed or a new group has been created.
*
* @param    int     $grp_id     Group ID
* @param    string  $mode       type of change: 'new', 'edit', or 'delete'
* @return   void
*
*/
function plugin_group_changed_forum($grp_id, $mode)
{
    global $_TABLES, $_GROUPS, $CONF_FORUM;

    if ($mode == 'delete') {
        // Change any deleted group ids to Forum Admin if exist, if does not change to root group
        $new_group_id = 0;
        if (isset($_GROUPS['forum Admin'])) {
            $new_group_id = $_GROUPS['forum Admin'];
        } else {
            $new_group_id = DB_getItem($_TABLES['groups'], 'grp_id', "grp_name = 'forum Admin'");
            if ($new_group_id == 0) {
                if (isset($_GROUPS['Root'])) {
                    $new_group_id = $_GROUPS['Root'];
                } else {
                    $new_group_id = DB_getItem($_TABLES['groups'], 'grp_id', "grp_name = 'Root'");
                }
            }
        }

        // Update Forum Side Block group if need be
        if ($CONF_FORUM['sideblock_group_id'] == $grp_id) {
            // Now save it to the configuration
            $c = config::get_instance();
            $c->set('sideblock_group_id', $new_group_id, 'forum');

        }
   }
}

/**
 * Config Manager function
 *
 * @return   array   Array of (groud id, group name) pairs
 *
 */
function plugin_configmanager_select_sideblock_group_id_forum()
{
    return SEC_getUserGroups();
}

/**
 * Config Manager function
 *
 * @return   array   Array of (topic id, topic name) pairs
 *
 */
function plugin_configmanager_select_sideblock_topic_forum()
{
    return array_flip(TOPIC_getList());
}

/**
* Callback function when an item was saved
*
* @param    string  $id     (unused) ID of item being saved
* @param    string  $type   type of item ('article', 'staticpages', ...)
* @param    string  $old_id (unused) previous ID of item, if != $id
* @return   void
* @see      PLG_itemSaved
*
*/
function plugin_itemsaved_forum($id, $type, $old_id)
{
    global $_TABLES, $CONF_FORUM;

    // we're really only interested in Topic ID changes
    if (($type == 'topic') && !empty($old_id) && ($id != $old_id)) {
        $key = array_search($old_id, $CONF_FORUM['sideblock_topic']);

        if ($key > 0) {
            // Update config
            $CONF_FORUM['sideblock_topic'][$key] = $id;

            // Now save it to the configuration
            $c = config::get_instance();
            $c->set('sideblock_topic', $CONF_FORUM['sideblock_topic'], 'forum');
        }
    }
}

/**
* Callback function when an item was deleted
*
* @param    string  $id     ID of item being deleted
* @param    string  $type   type of item ('article', 'staticpages', ...)
* @return   void
* @see      PLG_itemDeleted
*
*/
function plugin_itemdeleted_forum($id, $type)
{
    global $_TABLES, $CONF_FORUM;

    // we're really only interested in Topic Deletes
    if ($type == 'topic') {
        $key = array_search($id, $CONF_FORUM['sideblock_topic']);

        if ($key > 0) {
            // delete item from config
            unset($CONF_FORUM['sideblock_topic'][$key]);

            // Now save it to the configuration
            $c = config::get_instance();
            $c->set('sideblock_topic', $CONF_FORUM['sideblock_topic'], 'forum');
        }
        // Note: All topics could get deleted from array which would mean the block would not display untill user adds more in config
    }

}

/**
 * Return an array of Block Locations in plugin templates
 */
function plugin_getBlockLocations_forum()
{
    global $LANG_GF20;

    $block_locations = array();

    // Add any extra block locations for plugin
    // Remember these locations can only appear in templates that PLG_templateSetVars is used with
    $block_locations[] = array(
        'id'                => 'forum_showtopic', // Unique string. No other block location (includes Geeklog itself and any other plugins or themes) can share the same id ("left" and "right" are already taken).
        'name'              => $LANG_GF20['blocks_showtopic_name'],
        'description'       => $LANG_GF20['blocks_showtopic_desc'],
        'template_name'     => 'forum_showtopic',
        'template_variable' => 'blocks_showtopic'
    );

    return $block_locations;
}

/**
 * Did user create any forum posts
 *
 * @return   string   number of posts user contributed. If nothing leave blank
 */
function plugin_usercontributed_forum($uid)
{
    global $_TABLES, $LANG_GF02;

    $retval = '';

    $count = DB_getItem($_TABLES['forum_topic'], 'COUNT(uid)', "uid = {$uid}");

    if ($count > 0) {
        $retval = str_replace('%s', $count, $LANG_GF02['num_forumposts']);
    }

    return $retval;
}

/**
 * Is Likes system enabled for forum posts
 *
 * @return   int    0 = disabled, 1 = Likes and Dislikes, 2 = Likes only
 */
function plugin_likesenabled_forum($sub_type)
{
    global $CONF_FORUM;

    $retval = false;

    if ($CONF_FORUM['likes_forum'] > 0) {
        $retval = $CONF_FORUM['likes_forum'];
    }

    return $retval;
}

/**
 * Can user perform a like action on item
 * Note: $Id is filtered as a string by likes.php.
 *       If needed do additional checks here (like if you need a numeric value)
 *       but you cannot change the value of id since it will not change in the original calling function
 *
 * @return   bool
 */
function plugin_canuserlike_forum($sub_type, $id, $uid, $ip)
{
    global $CONF_FORUM, $_TABLES;

    $retval = false;

    if ($CONF_FORUM['likes_forum'] > 0) {
    	// Make sure $id is just a number as forum id is numeric
        // Cannot change id in this function, since the id from the calling function is used else where
		if (strval((int) $id) == $id) {
			// Figure out read permission for topic (based on Forum User Group assignment)
			$sql = "SELECT forum, uid, ip FROM {$_TABLES['forum_topic']} WHERE id = $id";
			$result = DB_query($sql);
			if (DB_numRows($result) > 0) {
				list ($forum, $owner_id, $owner_ip) = DB_fetchArray($result);

				$query = DB_query("SELECT grp_name FROM {$_TABLES['groups']} groups, {$_TABLES['forum_forums']} forum WHERE forum.forum_id='$forum' AND forum.grp_id=groups.grp_id");
				list ($groupname) = DB_fetchArray($query);
				// User belongs to security group so now check if owner of the item is the same as the visitor
				if (SEC_inGroup($groupname)) {
					if ($owner_id != $uid) {
						$retval = true;
					} elseif ($uid == 1 AND $owner_id == 1 AND $ip != $owner_ip) {
						$retval = true;
					}
				}
			}
		}
	}

    return $retval;
}

/**
 * Get URL for item like is for
 * Note: $Id is filtered as a string by likes.php.
 *       If needed do additional checks here (like if you need a numeric value)
 *       but you cannot change the value of id since it will not change in the original calling function
 *
 * @return   string    URL of item like is for
 */
function plugin_getItemLikeURL_forum($sub_type, $id)
{
    global $CONF_FORUM, $_TABLES;

    $retval = '';

    if ($CONF_FORUM['likes_forum'] > 0) {
        // Make sure $id is just a number as forum topic id is numeric
        // Cannot change id in this function, since the id from the calling function is used else where
        if (strval((int) $id) == $id) {
			// No sense rebuilding stuff here so use PLG_getItemInfo
			// PLG_getItemInfo will only return url if user has permissions
			$options['sub_type'] = $sub_type;
			$retval = PLG_getItemInfo(PLUGIN_NAME_FORUM, $id, 'url', 0, $options);
		}
    }

    return $retval;
}

/**
 * Return list of Forum Topics for the Related Items block
 *
 * @param    array $tids list of topic ids
 * @param    int   $max  maximum number of items to return
 * @param    int   $trim max length of text
 * @return   array   array of links to related staticpages with unix timestamp as key
 */
function plugin_getrelateditems_forum($tids, $max, $trim)
{
    global $_CONF, $_TABLES, $_GROUPS;

    // Note: This function currently only returns related forum topics that have been assigned directly to a topic
    // and inherited from a forum. It does not return topics inherited from a category or if defaulted using the forum config.

    $newforumtopics = array();

/*
    // Find newest Forum Topics user has access too
    $sql = "SELECT ft.id, ft.subject title, ft.date forum_date
        FROM {$_TABLES['topic_assignments']} ta, {$_TABLES['forum_topic']} ft, {$_TABLES['forum_forums']} ff
        WHERE ta.type = '" . PLUGIN_NAME_FORUM . "' AND ta.subtype = '" . TOPIC_TYPE_FORUM_TOPIC . "' AND ta.id = ft.id AND (ta.tid IN ('" . implode("','", $tids) . "'))
        AND ft.forum = ff.forum_id AND (ff.grp_id IN ('" . implode( "','", $_GROUPS ) . "')) AND ft.date <> 1 AND ft.pid = 0
        GROUP BY ft.id ORDER BY forum_date DESC LIMIT {$max}";
*/

    // Find newest Forum Topics user has access too. Check both forum topics and the forum itself
    $sql = "SELECT ft.id, ft.subject title, ft.date forum_date
        FROM {$_TABLES['topic_assignments']} ta, {$_TABLES['forum_topic']} ft, {$_TABLES['forum_forums']} ff
        WHERE ta.type = '" . PLUGIN_NAME_FORUM . "'
        AND ((ta.subtype = '" . TOPIC_TYPE_FORUM_TOPIC . "' AND ta.id = ft.id)
        OR (ta.subtype = '" . TOPIC_TYPE_FORUM_FORUM . "' AND ta.id = ft.forum))
        AND (ta.tid IN ('" . implode("','", $tids) . "'))
        AND ft.forum = ff.forum_id AND (ff.grp_id IN ('" . implode( "','", $_GROUPS ) . "')) AND ft.date <> 1 AND ft.pid = 0
        GROUP BY ft.id ORDER BY forum_date DESC LIMIT {$max}";
    $result = DB_query($sql);
    $nrows = DB_numRows($result);

    if ($nrows > 0) {
        $newforumtopics = array();

        for ($x = 0; $x < $nrows; $x++) {
            $A = DB_fetchArray($result);

			$url = forum_buildForumPostURL($A['id']);

            $title = COM_undoSpecialChars(stripslashes($A['title']));
            if ($trim > 0) {
                $titletouse = COM_truncate($title, $trim, '...');
            } else {
                $titletouse = $title;
            }
            if ($title != $titletouse) {
                $attr = array('title' => htmlspecialchars($title));
            } else {
                $attr = array();
            }
            $aforumtopic = str_replace('$', '&#36;', $titletouse);
            $aforumtopic = str_replace(' ', '&nbsp;', $aforumtopic);

            $newforumtopics[$A['forum_date']] = COM_createLink($aforumtopic, $url, $attr);
        }
    }

    return $newforumtopics;
}

/**
 * Return the info asked by PLG_collectRecaptchaInfo().
 *
 * @return  array of type => [
 *              'type'     => type               // required, passed as the 1st parameter to
 *                                                  plugin_templatesetvars_xxx()
 *              'version'  => reCAPTCHA version, // required: RECAPTCHA_NO_SUPPORT(0), RECAPTCHA_SUPPORT_V2(1),
 *                                                  RECAPTCHA_SUPPORT_V2_INVISIBLE(2)
 *              'form_id'  => form id,           // required only for reCAPTCHA V2 Invisible
 *           ]
 */
function plugin_supportsRecaptcha_forum()
{
    global $CONF_FORUM;

    return [
        [
            'type'    => 'forum',
            'version' => (isset($CONF_FORUM['recaptcha']) ? (int) $CONF_FORUM['recaptcha'] : RECAPTCHA_SUPPORT_V2_INVISIBLE),
            'form_id' => 'forumform',
        ],
    ];
}

?>
